<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'All Host Forest software is provided for free under a linkware license.
'You may modify any part of the software at your own risk, but the software
'(altered or otherwise) may not be distributed to entities beyond the
'license holder without the explicit written permission of the copyright holder.
'
'You may not remove, alter or otherwise disable all or any of the hyperlinks
'to the Host Forest website (http://www.hostforest.co.uk). All images, links or
'text must remain unchanged and intact and visible when the pages are viewed
'unless you first obtain explicit written permission from the copyright holders.
'
'Permission to remove the links, images and branding on a site by site basis
'basis can be obtained by purchasing the appropriate license from Host Forest
'by visiting http://www.hostforest.co.uk/Purchase/default.asp 
'
'You may not pass of in part or in whole any part of this software, including
'images and source code, as your own work. You may use parts of this program in
'your own private works, including images and source code, but you may NOT
'redistribute, repackage, sublicense or sell in part or in whole any part of
'this program regardless of any modifications that may have been made without
'the express written permission of the copyright holder.
'
'This software is provided WITHOUT warranty, either expressed or implied,
'including, but not limited to, the implied warranties of merchantability and
'fitness for a particular purpose. 
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->
<!--#include virtual="/Includes/inc-common.asp"-->

<%
'dimension variables
dim rsDetails, sqlDetails, intDetailsCount, arrDetailsData
dim strName, strPassword, strEmail

call validate_user()
%>

<title>Forest Site Administration</title>

<!--#include virtual="/Includes/inc-metadata.asp"-->

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/favicon.ico" />

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="content">
				<%
				'check whether form has been submitted
				if request.form = "" then
					
					'grab all user details
					set rsDetails = server.createobject("adodb.recordset")
					sqlDetails = "SELECT User_ID, User_Name, User_Password FROM FS_Users WHERE User_ID = "& session("FS_UserID") &";"
					rsDetails.cursorlocation = 3
					rsDetails.open sqlDetails, adoConn
					if not (rsDetails.bof or rsDetails.eof) then
						intDetailsCount = rsDetails.recordcount
						arrDetailsData = rsDetails.getrows()
					else
						intDetailsCount = 0
					end if
					rsDetails.close
					set rsDetails = nothing
					
					'increment query count
					intQuery = intQuery + 1
					
					'display account header
					response.write("<h1>Account settings</h1>")
					
					'display account details
					response.write("<p>")
						response.write("Use the form below to make any changes to your website administration account. Please make note of any changes that you make as they will become active next time that you log in.")
					response.write("</p>")
					
					'build account form
					response.write("<form action='account.asp' method='post' onsubmit=""this.submit.disabled=true;"">")
						
						response.write("<table cellspacing='0' summary='Your account details'>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='name'><b>Name</b></label>: *<br />Your administration account login name.</td>")
								response.write("<td class='details'><input id='name' name='name' type='text' value="""& SQL_decode(arrDetailsData(1, 0)) &""" size='22' maxlength='200' tabindex='1' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='password'><b>Password</b></label>: *<br />Please ensure that you use a secure password.</td>")
								response.write("<td class='details'><input id='password' name='password' type='password' value="""& SQL_decode(arrDetailsData(2, 0)) &""" size='22' maxlength='200' tabindex='2' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'>&nbsp;</td>")
								response.write("<td class='details'><input id='submit' name='submit' type='submit' tabindex='3' value=""Submit"" class='button' /></td>")
							response.write("</tr>")
							
						response.write("</table>")
						
					response.write("</form>")
					
				else
					
					'load and check variables		
					if clean_text(request.form("name"), 0) <> "" then
						strName = clean_text(request.form("name"), 0)
					else
						response.redirect("/Admin/error.asp?Type=Account&Error=Name&Redirect=/Admin/account.asp")
					end if
								
					if clean_text(request.form("password"), 0) <> "" then
						strPassword = clean_text(request.form("password"), 0)
					else
						response.redirect("/Admin/error.asp?Type=Account&Error=Password&Redirect=/Admin/account.asp")
					end if
					
					'update user details
					set rsDetails = server.createobject("adodb.recordset")
					sqlDetails = "UPDATE FS_Users SET User_Name = '"& strName &"', User_Password = '"& strPassword &"' WHERE User_ID = "& session("FS_UserID") &";"
					rsDetails.cursortype = 2
					rsDetails.locktype = 3
					rsDetails.open sqlDetails, adoConn
					set rsDetails = nothing
					
					'update user sessions
					session("FS_UserName") = strName
					
					'increment query count
					intQuery = intQuery + 1
					
					'display confirmation
					response.write("<h1>Account updated</h1>")
					response.write("Your account details have been successfully updated. Please click <a href='"& strSiteLocation &"/Admin' title='Administration'>here</a> if you are not redirected within 5 seconds.")
					
					'set redirection
					response.addheader "Refresh", "5; URL="& strSiteLocation &"/Admin"
					
				end if
				%>
			</div>
			
			<div id="subcontent">
				<%
				'display navigation
				call display_navigation()
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>