<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'All Host Forest software is provided for free under a linkware license.
'You may modify any part of the software at your own risk, but the software
'(altered or otherwise) may not be distributed to entities beyond the
'license holder without the explicit written permission of the copyright holder.
'
'You may not remove, alter or otherwise disable all or any of the hyperlinks
'to the Host Forest website (http://www.hostforest.co.uk). All images, links or
'text must remain unchanged and intact and visible when the pages are viewed
'unless you first obtain explicit written permission from the copyright holders.
'
'Permission to remove the links, images and branding on a site by site basis
'basis can be obtained by purchasing the appropriate license from Host Forest
'by visiting http://www.hostforest.co.uk/Purchase/default.asp 
'
'You may not pass of in part or in whole any part of this software, including
'images and source code, as your own work. You may use parts of this program in
'your own private works, including images and source code, but you may NOT
'redistribute, repackage, sublicense or sell in part or in whole any part of
'this program regardless of any modifications that may have been made without
'the express written permission of the copyright holder.
'
'This software is provided WITHOUT warranty, either expressed or implied,
'including, but not limited to, the implied warranties of merchantability and
'fitness for a particular purpose. 
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/func-upload.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->
<!--#include virtual="/Includes/inc-common.asp"-->

<%
'dimension variables
dim rsFolder, sqlFolder, intFolderCount, arrFolderData, rsFile, sqlFile
dim intFolderLoop, intFolder
dim strDestination
dim objUpload, objItem, item

call validate_user()
%>

<title>Forest Site Administration</title>

<!--#include virtual="/Includes/inc-metadata.asp"-->

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/favicon.ico" />

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="content">
				<%
				response.write("<h1>File uploader</h1>")
				response.write("<p>")
					response.write("Click the browse button below to locate files to upload to your webspace. Please note that the file uploader is only intended for small files, larger files should be uploaded over FTP.")
				response.write("</p>")
				
				response.write("<p>")
					response.write("<b>Caution</b>: The file uploader will overwrite any existing files in the destination folder that exist with the same name. Please ensure that you use unique names when uploading new files.")
				response.write("</p>")
				
				response.write("<form action='file_upload.asp?Action=Upload' enctype='multipart/form-data' method='post' onsubmit=""this.submit.disabled=true;"">")
					response.write("<table cellspacing='0' summary='Form for uploading new files.'>")
					
						'grab details of non-protected folders to populate folder form
						set rsFolder = server.createobject("adodb.recordset")
						sqlFolder = "SELECT Folder_ID, Folder_Title FROM FS_Folders WHERE Folder_Protected = 0 ORDER BY Folder_ID ASC;"
						rsFolder.cursorlocation = 3
						rsFolder.open sqlFolder, adoConn
						if not (rsFolder.bof or rsFolder.eof) then
							intFolderCount = rsFolder.recordcount
							arrFolderData = rsFolder.getrows()
						else
							intFolderCount = 0
						end if
						rsFolder.close
						set rsFolder = nothing
						
						'increment query count
						intQuery = intQuery + 1
						
						response.write("<tr valign='top'>")
							response.write("<td class='label'><label for='folder'><b>Upload folder</b></label>:<br />If you do not select an upload folder all images will be uploaded to the root directory.</td>")
							response.write("<td class='details'>")
								
								response.write("<select id='folder' name='folder' tabindex='1' class='select'>")
		
									response.write("<option value=""NULL"" selected='selected'>Root</option>")
									
									'initialise counter
									intFolderLoop = 0
									
									'loop through all available folders
									do until intFolderLoop = intFolderCount
										
										response.write("<option value="""& arrFolderData(0, intFolderLoop) &""">"& arrFolderData(1, intFolderLoop) &"</option>")
										
										'increment counter
										intFolderLoop = intFolderLoop + 1
										
									loop
									
								response.write("</select>")
								
							response.write("</td>")
						response.write("</tr>")
						response.write("<tr valign='top'>")
							response.write("<td class='label'><label for='strFileOne'><b>File One</b></label>:<br />The first file to upload.</td>")
							response.write("<td class='details'><input type='file' id='strFileOne' name='strFileOne' tabindex='2' class='browse' /></td>")
						response.write("</tr>")
						response.write("<tr valign='top'>")
							response.write("<td class='label'><label for='strFileTwo'><b>File Two</b></label>:<br />The second file to upload.</td>")
							response.write("<td class='details'><input type='file' id='strFileTwo' name='strFileTwo' tabindex='3' class='browse' /></td>")
						response.write("</tr>")
						response.write("<tr valign='top'>")
							response.write("<td class='label'><label for='strFileThree'><b>File Three</b></label>:<br />The third file to upload.</td>")
							response.write("<td class='details'><input type='file' id='strFileThree' name='strFileThree' tabindex='4' class='browse' /></td>")
						response.write("</tr>")
						response.write("<tr valign='top'>")
							response.write("<td class='label'></td>")
							response.write("<td class='details'><input id='submit' name='submit' type='submit' tabindex='5' value='upload' class='button' /></td>")
						response.write("</tr>")
					response.write("</table>")
				response.write("</form>")
				
				if request.querystring("Action") = "Upload" then
					
					'create upload component and initialise
					set objUpload = New clsUpload
					objUpload.RestrictFileExtentions = true
    				objUpload.SafeFileExtensions = "jpg|gif|png|bmp"
					objUpload.Upload ""
					
					
					'============================================
					'To allow other file types to be uploaded add their file extension to the list above seperated by pipes (|).
					'============================================
					
					'check files have been submitted
					if objUpload.Files.Count = 0 then
						
						'clean up and redirect
						set objUpload = nothing
						response.redirect("/Admin/error.asp?Type=Files&Error=Upload&Redirect=/Admin/file_upload.asp")
						
					end if
					
					'load and check variables
					if objUpload.Forms("folder") = "NULL" or objUpload.Forms("folder") = "" then
						intFolder = "NULL"
					else
						if isnumeric(objUpload.Forms("folder")) = true then
							intFolder = int(objUpload.Forms("folder"))
						else
							intFolder = "NULL"
						end if
					end if
					
					'check whether folder has been specified
					if intFolder <> "NULL" then
					
						'grab folder details
						set rsFolder = server.createobject("adodb.recordset")
						sqlFolder = "SELECT Folder_ID, Folder_Title FROM FS_Folders WHERE Folder_ID = "& intFolder &";"
						rsFolder.cursorlocation = 3
						rsFolder.open sqlFolder, adoConn
						if not (rsFolder.bof or rsFolder.eof) then
							intFolderCount = rsFolder.recordcount
							arrFolderData = rsFolder.getrows()
						else
							intFolderCount = 0
						end if
						rsFolder.close
						set rsFolder = nothing
						
						'increment query count
						intQuery = intQuery + 1
						
						'check valid folder was specified
						if intFolderCount = 0 then
							
							'clean up and redirect
							set objupload = nothing
							response.redirect("/Admin/error.asp?Type=Files&Error=Folder&Redirect=/Admin/file_upload.asp")
							
						end if
						
					end if	

					'determine upload directory
					if intFolderCount = 0 or intFolder = "NULL" then
						strDestination = server.mappath("..")
					else
						strDestination = server.mappath("..") &"/"& arrFolderData(1, 0)
					end if
					
					'display file upload message
					response.write("<h2>Upload successfull</h2>")
					
					response.write("<p>")
						response.write("The following files have been uploaded successfully, please make a note of their location.")
					response.write("</p>")
					
					response.write("<ul>")
					
						'loop through all files submitted
						for each item in objUpload.Files
							
							'create file object
							set objItem = objUpload.Files(item)
							
							'set file destination and save
							objItem.uploadpath = strDestination
							objItem.save
							
							'update files database
							set rsFile = server.createobject("adodb.recordset")
							sqlFile = "INSERT INTO FS_Files (File_Folder_ID, File_Name, File_Location) VALUES ("& intFolder &", '"& objItem.FileName &"', '"& strSiteLocation & replace(objItem.UploadPath, server.mappath(".."), "") &"/"& objItem.FileName &"');"
							rsFile.cursortype = 2
							rsFile.locktype = 3
							rsFile.open sqlFile, adoConn
							set rsFile = nothing
							
							'display file location and size
							response.write("<li><b>"& strSiteLocation & replace(objItem.UploadPath, server.mappath(".."), "") &"/"& objItem.FileName &"</b> - "& objItem.size &"b</li>")
							
							'clean up
							set objItem = nothing
							
						next
					
					response.write("</ul>")
					
					'clean up
					set objUpload = nothing
				
				end if
				%> 
			</div>
			
			<div id="subcontent">
				<%
				'display navigation
				call display_navigation()
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>