<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'This software if free provided under a linkware license.
'you may modify any part of the software at your own risk
'under the license that accompanies it.
'
'You may not remove, alter or otherwise disable all or any of 
'the hyperlinks to the Host Forest website (http://www.hostforest.co.uk).
'
'All images, links or text must remain unchanged and intact and visible
'when the pages are viewed unless you first obtain explicit written
'permission from the copyright holders.
'
'This software is provided WITHOUT warranty, with the implied warranty
'of merchantability, fitness for purpose or any other wannaties whether
'expressed or implied.
'
'Support for the forums is provided at http://www.hostforest.co.uk/forums
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->
<!--#include virtual="/Includes/inc-common.asp"-->

<%
'dimension variables
dim rsFiles, sqlFiles, intFilesCount, arrFilesData
dim objFSO
dim strDestination
dim intFilesLoop, intFile

'load and check variables
if request.querystring("Delete") <> "" and isnumeric(request.querystring("Delete")) = true then
	intFile = clng(request.querystring("Delete"))
end if

call validate_user()
%>

<title>Forest Site Administration</title>

<!--#include virtual="/Includes/inc-metadata.asp"-->

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/favicon.ico" />

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="content">
				<%
				'check that file has not been submitted
				if intFile = "" then
				
					'display header
					response.write("<h1>File viewer</h1>")
					
					'display welcome message
					response.write("<p>")
						response.write("All of the files that have been uploaded to the Forest Site installation are listed below. Click the appropriate delete button to remove the file from your webspace.")
					response.write("</p>")
					
					'grab all uploaded file
					set rsFiles = server.createobject("adodb.recordset")
					sqlFiles = "SELECT File_ID, File_Name, File_Location FROM FS_Files ORDER BY File_Name ASC;"
					rsFiles.cursorlocation = 3
					rsFiles.open sqlFiles, adoConn
					if not (rsFiles.bof or rsFiles.eof) then
						intFilesCount = rsFiles.recordcount
						arrFilesData = rsFiles.getrows()						
					else
						intFilesCount = 0
					end if
					rsFiles.close
					set rsFiles = nothing
					
					'increment query count
					intQuery = intQuery + 1
					
					'build table container
					response.write("<table cellspacing='0' summary='List of all the uploaded files that exist within the website'>")
						
						'buid table header
						response.write("<tr>")
							
							response.write("<th>File Name</th><th>Location</th><th class='options'>Options</th>")
								
						response.write("</tr>")
						
						'initialise counter
						intFilesLoop = 0
						
						'loop through all files
						do until intFilesLoop = intFilesCount
							
							response.write("<tr>")
								
								response.write("<td>"& arrFilesData(1, intFilesLoop) &"</td><td><a href='"& arrFilesData(2, intFilesLoop) &"' title='"& arrFilesData(1, intFilesLoop) &"'>"& arrFilesData(2, intFilesLoop) &"</a></td><td class='options'><a href='file_view.asp?Delete="& arrFilesData(0, intFilesLoop) &"' title='Delete'>Delete</a></td>")
									
							response.write("</tr>")
							
							'increment counter
							intFilesLoop = intFilesLoop + 1
							
						loop
						
					response.write("</table>")
					
				else
					
					'look up file and folder details of specified file
					set rsFiles = server.createobject("adodb.recordset")
					sqlFiles = "SELECT Files.File_Name, Folders.Folder_Title FROM FS_Files AS Files LEFT JOIN FS_Folders AS Folders ON Files.File_Folder_ID = Folders.Folder_ID WHERE Files.File_ID = "& intFile &";"
					rsFiles.cursorlocation  = 3
					rsFiles.open sqlFiles, adoConn
					if not (rsFiles.bof or rsFiles.eof) then
						intFilesCount = rsFiles.recordcount
						arrFilesData = rsFiles.getrows()
					else
						intFilesData = 0
					end if
					rsFiles.close
					set rsFiles= nothing
						
					'increment query count
					intQuery = intQuery + 1
					
					'specify the physical location of the file
					if isnull(arrFilesData(1, 0)) = true then
						strDestination = server.mappath("..") &"\"& arrFilesData(0, 0)
					else
						strDestination = server.mappath("..") &"\"& arrFilesData(1, 0) &"\"& arrFilesData(0, 0)
					end if
					
					'create file system object
					set objFSO = server.createobject("scripting.filesystemobject")
						
					'delete file
					if objFSO.fileexists(strDestination) = true then
						objFSO.deletefile(strDestination)
					end if
					
					'clean up
					set objFSO = nothing
					
					'delete specified file from hte database
					set rsFiles = server.createobject("adodb.recordset")
					if isnull(arrFilesData(1, 0)) = true then
						sqlFiles = "DELETE FROM FS_Files WHERE File_Name = '"& arrFilesData(0, 0) &"' AND File_Folder_ID IS NULL;"
					else
						sqlFiles = "DELETE FROM FS_Files WHERE File_Name = '"& arrFilesData(0, 0) &"' AND File_Folder_ID = "& arrFilesData(1, 0) &";"
					end if
					rsFiles.cursortype = 2
					rsFiles.locktype = 3
					rsFiles.open sqlFiles, adoConn
					
					'increment query count
					intQuery = intQuery + 1
					
					'display confirmation
					response.write("<h1>File deleted</h1>")
					
					response.write("<p>")
						response.write("The specified file has been successfully deleted from your webspace and the corresponding entry has been removed from your database. Please click <a href='"& strSiteLocation &"/Admin' title='Administration'>here</a> if you are not redirected within 5 seconds.")
					response.write("</p>")
					
					'set redirection
					response.addheader "Refresh", "5; URL="& strSiteLocation &"/Admin"
					
				end if
				%>
			</div>
			
			<div id="subcontent">
				<%
				'display navigation
				call display_navigation()
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>