<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'All Host Forest software is provided for free under a linkware license.
'You may modify any part of the software at your own risk, but the software
'(altered or otherwise) may not be distributed to entities beyond the
'license holder without the explicit written permission of the copyright holder.
'
'You may not remove, alter or otherwise disable all or any of the hyperlinks
'to the Host Forest website (http://www.hostforest.co.uk). All images, links or
'text must remain unchanged and intact and visible when the pages are viewed
'unless you first obtain explicit written permission from the copyright holders.
'
'Permission to remove the links, images and branding on a site by site basis
'basis can be obtained by purchasing the appropriate license from Host Forest
'by visiting http://www.hostforest.co.uk/Purchase/default.asp 
'
'You may not pass of in part or in whole any part of this software, including
'images and source code, as your own work. You may use parts of this program in
'your own private works, including images and source code, but you may NOT
'redistribute, repackage, sublicense or sell in part or in whole any part of
'this program regardless of any modifications that may have been made without
'the express written permission of the copyright holder.
'
'This software is provided WITHOUT warranty, either expressed or implied,
'including, but not limited to, the implied warranties of merchantability and
'fitness for a particular purpose. 
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->
<!--#include virtual="/Includes/inc-common.asp"-->

<%
'dimension variables
dim rsFolder, sqlFolder
dim objFSO
dim regCharacters
dim strName, strMessage
dim booExists

call validate_user()
%>

<title>Forest Site Administration</title>

<!--#include virtual="/Includes/inc-metadata.asp"-->

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/favicon.ico" />

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="content">
				<%
				'check whether form has been submitted
				if request.form = "" then
					
					'display add folder header
					response.write("<h1>Add folders</h1>")
					
					'display add folder details
					response.write("<p>")
						response.write("Use the form below to add a new folder to the Forest Site. Please pay attention to the description of each value in the form below and click submit once you have made the necassary changes.")
					response.write("</p>")
					
					response.write("<p>")
						response.write("Completing this form will add a new folder to the root folder of the Forest Site installation and to the Forest Site database.")
					response.write("</p>")
					
					'build folder form
					response.write("<form action='folder_add.asp' method='post' onsubmit=""this.submit.disabled=true;"">")
						
						response.write("<table cellspacing='0' summary='Form for adding new folders.'>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='name'><b>Folder name</b></label>:<br />The name of the folder that you wish to create. Cannot contain any spaces.</td>")
								response.write("<td class='details'><input id='name' name='name' type='text' value="""" size='22' maxlength='200' tabindex='1' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'></td>")
								response.write("<td class='details'><input id='submit' name='submit' type='submit' tabindex='12' value=""Submit"" class='button' /></td>")
							response.write("</tr>")
							
						response.write("</table>")
						
					response.write("</form>")
					
				else
					
					'set regular expression to check for alpha characters only 
					set regCharacters = new regexp
					regCharacters.Pattern = "[a-zA-Z]"
					
					'load and check variables
					if clean_text(request.form("name"), 0) <> "" then
						if instr(request.form("name"), " ") = 0 and regCharacters.test(request.form("name")) = true then
							strName = request.form("name")
						else
							response.redirect("/Admin/error.asp?Type=Folders&Error=Name&Redirect=/Admin/folder_add.asp")
						end if
					else
						response.redirect("/Admin/error.asp?Type=Folders&Error=Name&Redirect=/Admin/folder_add.asp")
					end if
					
					'create file system object to create folder
					set objFSO= server.createobject("scripting.filesystemobject")

					'check whether folder already exists
					if objFSO.FolderExists(server.mappath("..") &"/"& strName) = false then
					 	
						'create the folder
						objFSO.createfolder(server.mappath("..") &"/"& strName)
						
						'add folder to the database 
						set rsFolder = server.createobject("adodb.recordset")
						sqlFolder = "INSERT INTO FS_Folders (Folder_Title, Folder_System, Folder_Protected) VALUES ('"& strName &"', 0, 0);"
						rsFolder.cursortype = 2
						rsFolder.locktype = 3
						rsFolder.open sqlFolder, adoConn
						set rsFolder = nothing
						
						'increment query count
						intQuery = intQuery + 1
						
						strMessage = "The specified folder has now been created and added to the database."
						
					else
						
						'look up folder in the database
						set rsFolder = server.createobject("adodb.recordset")
						sqlFolder = "SELECT * FROM FS_Folders WHERE Folder_Title = '"& strName &"';"
						rsFolder.cursorlocation = 3
						rsFolder.open sqlFolder, adoConn
						if not (rsFolder.bof or rsFolder.eof) then
							booExists = true
						else
							booExists = false
						end if
						rsFolder.close
						set rsFolder= nothing
						
						'increment query count
						intQuery = intQuery + 1
						
						'check whether folder exists within the Forest Site installation
						if booExists = false then
							
							strMessage = "The folder name that you have specified already exists on the server but is not part of the Forest Site structure and cannot be added."
							
						else
							
							strMessage = "The specified folder already exists on the server and in the database, no action has been taken."
								
						end if
						
					end if
					
					'close file system object
					set objFSO = nothing
					
					'display confirmation
					response.write("<h1>Folder added</h1>")
					
					response.write("<p>")
						response.write(strMessage &" Please click <a href='"& strSiteLocation &"/Admin' title='Administration'>here</a> if you are not redirected within 5 seconds.")
					response.write("</p>")
					
					'set redirection
					response.addheader "Refresh", "5; URL="& strSiteLocation &"/Admin"
					
				end if
				%>
			</div>
			
			<div id="subcontent">
				<%
				'display navigation
				call display_navigation()
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>