<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'All Host Forest software is provided for free under a linkware license.
'You may modify any part of the software at your own risk, but the software
'(altered or otherwise) may not be distributed to entities beyond the
'license holder without the explicit written permission of the copyright holder.
'
'You may not remove, alter or otherwise disable all or any of the hyperlinks
'to the Host Forest website (http://www.hostforest.co.uk). All images, links or
'text must remain unchanged and intact and visible when the pages are viewed
'unless you first obtain explicit written permission from the copyright holders.
'
'Permission to remove the links, images and branding on a site by site basis
'basis can be obtained by purchasing the appropriate license from Host Forest
'by visiting http://www.hostforest.co.uk/Purchase/default.asp 
'
'You may not pass of in part or in whole any part of this software, including
'images and source code, as your own work. You may use parts of this program in
'your own private works, including images and source code, but you may NOT
'redistribute, repackage, sublicense or sell in part or in whole any part of
'this program regardless of any modifications that may have been made without
'the express written permission of the copyright holder.
'
'This software is provided WITHOUT warranty, either expressed or implied,
'including, but not limited to, the implied warranties of merchantability and
'fitness for a particular purpose. 
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->
<!--#include virtual="/Includes/inc-common.asp"-->

<%
'dimension variables
dim rsFolder, sqlFolder, intFolderCount, arrFolderData, rsPages, sqlPages
dim objFSO
dim intFolder, intFolderLoop
dim booPages

'load and check variables
if request.querystring("Folder") <> "" and isnumeric(request.querystring("Folder")) = true then
	intFolder = int(request.querystring("Folder"))
end if

call validate_user()
%>

<title>Forest Site Administration</title>

<!--#include virtual="/Includes/inc-metadata.asp"-->

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/favicon.ico" />

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="content">
				<%
				'check whether folder has been specified
				if intFolder = "" then
					
					'display edit folder header
					response.write("<h1>Delete folders</h1>")
					
					response.write("<p>")
						response.write("The details of all of the folders currently defined in the Forest Site are listed below. Click on the appropriate <i>delete</i> link to delete the specified folder.")
					response.write("</p>")
					
					response.write("<p>")
						response.write("System folders are those used by the Forest Site software and cannot be deleted. If a folder is protected it means that no further pages may be added to it.")
					response.write("</p>")
					
					'look up all folder details
					set rsFolder = server.createobject("adodb.recordset")
					sqlFolder = "SELECT Folder_ID, Folder_Title, Folder_System, Folder_Protected FROM FS_Folders ORDER BY Folder_ID ASC;"
					rsFolder.cursorlocation = 3
					rsFolder.open sqlFolder, adoConn
					if not (rsFolder.bof or rsFolder.eof) then
						intFolderCount = rsFolder.recordcount
						arrFolderData = rsFolder.getrows()
					else
						intFolderCount = 0
					end if
					rsFolder.close
					set rsFolder= nothing
					
					'increment query count
					intQuery = intQuery + 1
					
					'check whether folders have been returned
					if intFolderCount = 0 then
						response.redirect("/Admin/error.asp?Type=Folders&Error=Folders&Redirect=/Admin/folder_delete.asp")
					end if
					
					'build table container
					response.write("<table cellspacing='0' summary='List of all the folders that exist within the database'>")
						
						'buid table header
						response.write("<tr>")
							
							response.write("<th>Folder Name</th><th class='options'>System</th><th class='options'>Protected</th><th class='options'>Options</th>")
								
						response.write("</tr>")
						
						'initialise counter
						intFolderLoop = 0
						
						'loop through all folders
						do until intFolderLoop = intFolderCount
							
							response.write("<tr>")
								
								'display folder title
								response.write("<td>"& arrFolderData(1, intFolderLoop) &"</td>")
								
								response.write("<td class='options'>")
									
									'check whether folder is a system folder
									if int(arrFolderData(2, intFolderLoop)) = 1 then
										response.write("Yes")
									else
										response.write("No")
									end if
									
								response.write("</td>")
								
								response.write("<td class='options'>")
									
									'check whether folder is protected
									if int(arrFolderData(3, intFolderLoop)) = 1 then
										response.write("Yes")
									else
										response.write("No")
									end if
									
								response.write("</td>")
								
								response.write("<td class='options'>")
									
									'check whether folder is a system folder
									if int(arrFolderData(2, intFolderLoop)) = 1 then
										response.write("None")
									else
										response.write("<a href='folder_delete.asp?Folder="& arrFolderData(0, intFolderLoop) &"' title='Delete folder'>Delete</a>")
									end if
									
								response.write("</td>")
								
							response.write("</tr>")
							
							'increment counter
							intFolderLoop = intFolderLoop + 1
						
						loop
						
					response.write("</table>")
					
				else
					
					'check that the folder exists and is not a system folder
					set rsFolder = server.createobject("adodb.recordset")
					sqlFolder = "SELECT Folder_ID, Folder_Title, Folder_System FROM FS_Folders WHERE Folder_ID = "& intFolder &";"
					rsFolder.cursorlocation = 3
					rsFolder.open sqlFolder, adoConn
					if not (rsFolder.bof or rsFolder.eof) then
						intFolderCount = rsFolder.recordcount
						arrFolderData = rsFolder.getrows()
					else
						intFolderCount = 0
					end if
					rsFolder.close
					set rsFolder = nothing
					
					'increment query count
					intQuery = intQuery + 1
					
					'check whether a valid folder has been specified
					if intFolderCount = 0 then
						response.redirect("/Admin/error.asp?Type=Folders&Error=Invalid&Redirect=/Admin/folder_delete.asp")
					end if
					
					'check whether folder is a system folder
					if arrFolderData(2, 0) then
						response.redirect("/Admin/error.asp?Type=Folders&Error=System&Redirect=/Admin/folder_delete.asp")
					end if
					
					'look up pages assigned to this folder
					set rsPages = server.createobject("adodb.recordset")
					sqlPages = "SELECT * FROM FS_Pages WHERE Page_Folder_ID = "& intFolder &";"		
					rsPages.cursorlocation = 3
					rsPages.open sqlPages, adoConn
					if not (rsPages.bof or rsPages.eof) then
						booPages = true
					else
						booPages = false
					end if
					rsPages.close
					set rsPages = nothing			
					
					'check whether folder contains any pages
					if booPages = true then
						response.redirect("/Admin/error.asp?Type=Folders&Error=Pages&Redirect=/Admin/folder_delete.asp")
					end if
					
					'create file system object to create folder
					set objFSO= server.createobject("scripting.filesystemobject")
					
					'delete physical folder
					objFSO.DeleteFolder(server.mappath("..") &"/"& arrFolderData(1, 0))
					
					'close file system object
					set objFSO = nothing
					
					'delete folder from database
					set rsFolder = server.createobject("adodb.recordset")
					sqlFolder = "DELETE FROM FS_Folders WHERE Folder_ID = "& intFolder &";"
					rsFolder.cursortype = 2
					rsFolder.locktype = 3
					rsFolder.open sqlFolder, adoConn
					set rsFolder = nothing
					
					'display confirmation
					response.write("<h1>Folder deleted</h1>")
					
					response.write("<p>")
						response.write("The specified folder has been successfully deleted. Please click <a href='"& strSiteLocation &"/Admin' title='Administration'>here</a> if you are not redirected within 5 seconds.")
					response.write("</p>")
					
					'set redirection
					response.addheader "Refresh", "5; URL="& strSiteLocation &"/Admin"
					
				end if
				%>
			</div>
			
			<div id="subcontent">
				<%
				'display navigation
				call display_navigation()
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>