<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'All Host Forest software is provided for free under a linkware license.
'You may modify any part of the software at your own risk, but the software
'(altered or otherwise) may not be distributed to entities beyond the
'license holder without the explicit written permission of the copyright holder.
'
'You may not remove, alter or otherwise disable all or any of the hyperlinks
'to the Host Forest website (http://www.hostforest.co.uk). All images, links or
'text must remain unchanged and intact and visible when the pages are viewed
'unless you first obtain explicit written permission from the copyright holders.
'
'Permission to remove the links, images and branding on a site by site basis
'basis can be obtained by purchasing the appropriate license from Host Forest
'by visiting http://www.hostforest.co.uk/Purchase/default.asp 
'
'You may not pass of in part or in whole any part of this software, including
'images and source code, as your own work. You may use parts of this program in
'your own private works, including images and source code, but you may NOT
'redistribute, repackage, sublicense or sell in part or in whole any part of
'this program regardless of any modifications that may have been made without
'the express written permission of the copyright holder.
'
'This software is provided WITHOUT warranty, either expressed or implied,
'including, but not limited to, the implied warranties of merchantability and
'fitness for a particular purpose. 
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->
<!--#include virtual="/Includes/inc-common.asp"-->

<%
'dimension variables
dim rsPage, sqlPage, intPageCount, arrPageData, rsFolder, sqlFolder, intFolderCount, arrFolderData
dim objFSO, objTemplate, objPage
dim regCharacters
dim strTitle, strName, strContent, strImage, strAddress, strDestination, strTemplate, strPage
dim intPageLoop, intFolderLoop, intVisibility, intParent, intFolder, intOrder, intBegin, intEnd

call validate_user()
%>

<title>Forest Site Administration</title>

<!--#include virtual="/Includes/inc-metadata.asp"-->

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/favicon.ico" />

<script language="javascript" type="text/javascript" src="<%=strSiteLocation%>/Includes/Tiny/tiny_mce.js"></script>
<script language="javascript" type="text/javascript">
	tinyMCE.init
	(
		{
			theme : "advanced",
			mode : "textareas",
			theme_advanced_containers : "mceControls,mceEditor",
			theme_advanced_container_mceControls:  'formatselect,separator,bold,italic,underline,strikethrough,separator,justifyleft,justifycenter,justifyright,justifyfull,outdent,indent,numlist,bullist,separator,link,unlink,anchor,image,separator,undo,redo,code,fullscreen',
			theme_advanced_layout_manager : "RowLayout",
			theme_advanced_toolbar_location : "top",
			remove_linebreaks : false,
			plugins : "codeprotect,fullscreen",
			convert_urls: false,
			entities : "",
			debug : false
		}
	);
</script>

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="content">
				<%
				'check whether the form has been submitted
				if request.form = "" then
					
					'display page header
					response.write("<h1>Add Pages</h1>")
					
					'display page details
					response.write("<p>")
						response.write("Use the form below to add a new page to the Forest Site. Please pay attention to the description of each value and click submit once you have made the necassary changes.")
					response.write("</p>")
					
					response.write("<p>")
						response.write("There are two types of page that you can add to your Forest Site, a link page or a physical page. A link page adds a page link to the database without creating a physical page in the Forest Site. Where as a physical page adds both a page link in the database and creates a physical page in the Forest Site structure.")
					response.write("</p>")
					
					response.write("<p>")
						response.write("Link pages should be used if you want to add a link to a pre-existing page to the main structure of the Forest Site, for all other pages you should create a physical page.")
					response.write("</p>")
					
					'display link page header
					response.write("<h2>Add a link page</h2>")
					
					'display link page form
					response.write("<form action='page_add.asp' method='post' onsubmit=""this.submit.disabled=true;"">")
						
						response.write("<table cellspacing='0' summary='Form for adding new link page.'>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='title'><b>Page title</b></label>:<br />Sets the pages title, this is what will appear in all menus.</td>")
								response.write("<td class='details'><input id='title' name='title' type='text' value="""" size='22' maxlength='200' tabindex='1' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='image'><b>Page image</b></label>:<br />Sets the pages image, this is what will appear in all menus.</td>")
								response.write("<td class='details'><input id='image' name='image' type='text' value="""" size='22' maxlength='200' tabindex='2' class='text' /></td>")
							response.write("</tr>")
							
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='address'><b>Page address</b></label>:<br />Sets the URL that the page links to.</td>")
								response.write("<td class='details'><input id='address' name='address' type='text' value="""" size='22' maxlength='200' tabindex='3' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'></td>")
								response.write("<td class='details'><input name='type' type='hidden' value=""link"" /><input id='submit' name='submit' type='submit' tabindex='4' value=""Submit"" class='button' /></td>")
							response.write("</tr>")
							
						response.write("</table>")
						
					response.write("</form>")
					
					'display physical page header
					response.write("<h2>Add a physical page</h2>")
					
					'display physical page form
					response.write("<form action='page_add.asp' method='post' onsubmit=""this.submit.disabled=true;"">")
						
						response.write("<table cellspacing='0' summary='Form for adding new physical page.'>")
							
							'grab details of non-protected folders to populate folder form
							set rsFolder = server.createobject("adodb.recordset")
							sqlFolder = "SELECT Folder_ID, Folder_Title FROM FS_Folders WHERE Folder_Protected = 0 ORDER BY Folder_ID ASC;"
							rsFolder.cursorlocation = 3
							rsFolder.open sqlFolder, adoConn
							if not (rsFolder.bof or rsFolder.eof) then
								intFolderCount = rsFolder.recordcount
								arrFolderData = rsFolder.getrows()
							else
								intFolderCount = 0
							end if
							rsFolder.close
							set rsFolder = nothing
							
							'increment query count
							intQuery = intQuery + 1
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='folder'><b>Page folder</b></label>:<br />If you do not assign a folder for the page it will be created in the root of the Forest Site directory.</td>")
								response.write("<td class='details'>")
									
									response.write("<select id='folder' name='folder' tabindex='6' class='select'>")

										response.write("<option value=""NULL"" selected='selected'>None</option>")
										
										'initialise counter
										intFolderLoop = 0
										
										'loop through all available folders
										do until intFolderLoop = intFolderCount
											
											response.write("<option value="""& arrFolderData(0, intFolderLoop) &""">"& arrFolderData(1, intFolderLoop) &"</option>")
											
											'increment counter
											intFolderLoop = intFolderLoop + 1
											
										loop
										
									response.write("</select>")
									
								response.write("</td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='title'><b>Page title</b></label>:<br />Sets the pages title, this is what will appear in all menus.</td>")
								response.write("<td class='details'><input id='title' name='title' type='text' value="""" size='22' maxlength='200' tabindex='7' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='name'><b>Page name</b></label>:<br />Sets the pages physical name, do not include any file extension as this will be added automatically.</td>")
								response.write("<td class='details'><input id='name' name='name' type='text' value="""" size='22' maxlength='200' tabindex='8' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='text'><b>Page content</b></label>:<br />Sets the page content, you can enter any HTML or ASP code as long as it is within the appropriate tags.</td>")
								response.write("<td class='details'><textarea id='text' name='text' cols='' rows='10' tabindex='9' class='textarea'></textarea></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='image'><b>Page image</b></label>:<br />Sets the pages image, this is what will appear in all menus.</td>")
								response.write("<td class='details'><input id='image' name='image' type='text' value="""" size='22' maxlength='200' tabindex='10' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'></td>")
								response.write("<td class='details'><input name='type' type='hidden' value=""physical"" /><input id='submit' name='submit' type='submit' tabindex='11' value=""Submit"" class='button' /></td>")
							response.write("</tr>")
							
						response.write("</table>")
						
					response.write("</form>")
					
				else
					
					'check what type of page is being added 
					select case request.form("type")
						
						case "link"
							
							'load and check variables
							if clean_text(request.form("title"), 0) <> "" then
								strTitle = clean_text(request.form("title"), 0)
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Title&Redirect=/Admin/page_add.asp")
							end if
							
							if clean_text(request.form("image"), 0) <> "" then
								strImage = clean_text(request.form("image"), 0)
							else
								strImage = NULL
							end if
							
							if clean_text(request.form("address"), 0) <> "" then
								if left(request.form("address"), 7) <> "http://" then
									strAddress = "http://"& clean_text(request.form("address"), 0)
								else
									strAddress = clean_text(request.form("address"), 0)
								end if
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Address&Redirect=/Admin/page_add.asp")
							end if
							
							'check whether page title is already in use within parent page
							set rsPage = server.createobject("adodb.recordset")
							sqlPage = "SELECT Page_ID, Page_Title FROM FS_Pages WHERE Page_Title = '"& strTitle &"';"							
							rsPage.cursorlocation = 3
							rsPage.open sqlPage, adoConn
							if not (rsPage.bof or rsPage.eof) then
								intPageCount = rsPage.recordcount
								arrPageData = rsPage.getrows()
							else
								intPageCount = 0
							end if
							rsPage.close
							set rsPage = nothing
							
							'increment query count
							intQuery = intQuery + 1
							
							if intPageCount <> 0 then
								response.redirect("/Admin/error.asp?Type=Page&Error=Duplicate&Redirect=/Admin/page_add.asp")
							end if
							
							'check what order to insert the page in
							set rsPage = server.createobject("adodb.recordset")
							sqlPage = "SELECT * FROM FS_Pages;"
							rsPage.cursorlocation = 3
							rsPage.open sqlPage, adoConn
							intOrder = rsPage.recordcount
							rsPage.close
							set rsPage = nothing
							
							'insert link page
							set rsPage = server.createobject("adodb.recordset")
							sqlPage = "INSERT INTO FS_Pages (Page_Title, Page_Image, Page_Type, Page_URL, Page_Order) VALUES ('"& strTitle &"', '"& strImage &"', 1, '"& strAddress &"', "& intOrder &");"
							rsPage.cursortype = 2
							rsPage.locktype = 3
							rsPage.open sqlPage, adoConn
							set rsPage = nothing
							
							'display confirmation
							response.write("<h1>Link page added</h1>")
							
							response.write("<p>")
								response.write("The new link page has been successfully added. Please click <a href='"& strSiteLocation &"/Admin' title='Administration'>here</a> if you are not redirected within 5 seconds.")
							response.write("</p>")
							
							'set redirection
							response.addheader "Refresh", "5; URL="& strSiteLocation &"/Admin"
							
						case "physical"
							
							'set regular expression to check for alpha characters only 
							set regCharacters = new regexp
							regCharacters.Pattern = "[a-zA-Z]"
							
							'check what order to insert the page in
							set rsPage = server.createobject("adodb.recordset")
							sqlPage = "SELECT * FROM FS_Pages;"
							rsPage.cursorlocation = 3
							rsPage.open sqlPage, adoConn
							intOrder = rsPage.recordcount
							rsPage.close
							set rsPage = nothing
							
							'increment query count
							intQuery = intQuery + 1
							
							if request.form("folder") = "NULL" or request.form("folder") = "" then
								intFolder = "NULL"
							else
								if isnumeric(request.form("folder")) = true then
									intFolder = int(request.form("folder"))
								else
									intFolder = "NULL"
								end if
							end if
							
							'check whether folder has been specified
							if intFolder <> "NULL" then
							
								'grab folder details
								set rsFolder = server.createobject("adodb.recordset")
								sqlFolder = "SELECT Folder_ID, Folder_Title FROM FS_Folders WHERE Folder_ID = "& intFolder &";"
								rsFolder.cursorlocation = 3
								rsFolder.open sqlFolder, adoConn
								if not (rsFolder.bof or rsFolder.eof) then
									intFolderCount = rsFolder.recordcount
									arrFolderData = rsFolder.getrows()
								else
									intFolderCount = 0
								end if
								rsFolder.close
								set rsFolder = nothing
								
								'increment query count
								intQuery = intQuery + 1
								
								'check valid folder was specified
								if intFolderCount = 0 then
									response.redirect("/Admin/error.asp?Type=Page&Error=Folder&Redirect=/Admin/page_add.asp")
								end if
								
							end if
							
							if clean_text(request.form("title"), 0) <> "" then
								strTitle = clean_text(request.form("title"), 0)
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Title&Redirect=/Admin/page_add.asp")
							end if
							
							'load and check variables
							if clean_text(request.form("name"), 0) <> "" then
								if instr(request.form("name"), " ") = 0 and regCharacters.test(request.form("name")) = true then
									strName = request.form("name") &".asp"
								else
									response.redirect("/Admin/error.asp?Type=Page&Error=Name&Redirect=/Admin/page_add.asp")
								end if
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Name&Redirect=/Admin/page_add.asp")
							end if
							
							strContent = request.form("text")
							
							if clean_text(request.form("image"), 0) <> "" then
								strImage = clean_text(request.form("image"), 0)
							else
								strImage = NULL
							end if
							
							if intPageCount <> 0 then
								response.redirect("/Admin/error.asp?Type=Page&Error=Duplicate&Redirect=/Admin/page_add.asp")
							end if
							
							'check whether page name already exists within the specified folder
							set rsPage = server.createobject("adodb.recordset")
							sqlPage = "SELECT Page_ID, Page_Name FROM FS_Pages WHERE Page_Name = '"& strName &"' "
							
							'specify page folder
							if intFolder = "NULL" then
								sqlPage = sqlPage &"AND Page_Folder_ID IS NULL;"
							else
								sqlPage = sqlPage &"AND Page_Folder_ID = "& intFolder &";"
							end if
							
							rsPage.cursorlocation = 3
							rsPage.open sqlPage, adoConn
							if not (rsPage.bof or rsPage.eof) then
								intPageCount = rsPage.recordcount
								arrPageData = rsPage.getrows()
							else
								intPageCount = 0
							end if
							rsPage.close
							set rsPage = nothing
							
							'increment query count
							intQuery = intQuery + 1
							
							if intPageCount <> 0 then
								response.redirect("/Admin/error.asp?Type=Page&Error=Duplicate&Redirect=/Admin/page_add.asp")
							end if
							
							'set physical page destination and page URL
							if intFolderCount = 0 then
								strDestination = server.mappath("..") &"\"& strName
								strAddress = strSiteLocation &"/"& strName
							else
								strDestination = server.mappath("..") &"\"& arrFolderData(1, 0) &"\"& strName
								strAddress = strSiteLocation &"/"& arrFolderData(1, 0) &"/"& strName
							end if
							
							'create file system object
							set objFSO = server.createobject("scripting.filesystemobject")
							
							'read in template page
							set objTemplate = objFSO.opentextfile(server.mappath("..") &"/Includes/template-page.asp")
							strTemplate = objTemplate.readall
							set objTemplate = nothing
							
							'look up position begin editing tag, count from the begining of the template
							intBegin = instr(strTemplate, "<!--begin content-->") + 21
							
							'look up position end editing tag, count from the end of the template
							intEnd = len(strTemplate) - instr(strTemplate, "<!--end content-->") + 1
							
							'insert page content
							strPage = left(strTemplate, intBegin) & strContent & vbcrlf & right(strTemplate, intEnd)
							
							'replace page title
							strPage = replace(strPage, "{TITLE}", strTitle)
							
							'write new page
							set objPage = objFSO.createtextfile(strDestination)
							objPage.writeline(strPage)
							objPage.close
							set objPage = nothing
							
							'close file system object
							set objFSO = nothing
							
							'add page to database
							set rsPage = server.createobject("adodb.recordset")
							sqlPage = "INSERT INTO FS_Pages (Page_Folder_ID, Page_Type, Page_Title, Page_Image, Page_Name, Page_URL, Page_Order) VALUES ("& intFolder &", 0, '"& strTitle &"', '"& strImage &"', '"& strName &"', '"& strAddress &"', "& intOrder &");"
							rsPage.cursortype = 2
							rsPage.locktype = 3
							rsPage.open sqlPage, adoConn
							set rsPage = nothing
							
							'increment query count
							intQuery = intQuery + 1
							
							'display confirmation
							response.write("<h1>Physical page added</h1>")
							
							response.write("<p>")
								response.write("The physical page has been successfully added. Please click <a href='"& strSiteLocation &"/Admin' title='Administration'>here</a> if you are not redirected within 5 seconds.")
							response.write("</p>")
							
							'set redirection
							response.addheader "Refresh", "5; URL="& strSiteLocation &"/Admin"
							
							
						case else
							
							response.redirect("/Admin/error.asp?Type=Page&Error=Type&Redirect=/Admin/page_add.asp")
							
					end select
					
				end if
				%>
			</div>
			
			<div id="subcontent">
				<%
				'display navigation
				call display_navigation()
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>