<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'All Host Forest software is provided for free under a linkware license.
'You may modify any part of the software at your own risk, but the software
'(altered or otherwise) may not be distributed to entities beyond the
'license holder without the explicit written permission of the copyright holder.
'
'You may not remove, alter or otherwise disable all or any of the hyperlinks
'to the Host Forest website (http://www.hostforest.co.uk). All images, links or
'text must remain unchanged and intact and visible when the pages are viewed
'unless you first obtain explicit written permission from the copyright holders.
'
'Permission to remove the links, images and branding on a site by site basis
'basis can be obtained by purchasing the appropriate license from Host Forest
'by visiting http://www.hostforest.co.uk/Purchase/default.asp 
'
'You may not pass of in part or in whole any part of this software, including
'images and source code, as your own work. You may use parts of this program in
'your own private works, including images and source code, but you may NOT
'redistribute, repackage, sublicense or sell in part or in whole any part of
'this program regardless of any modifications that may have been made without
'the express written permission of the copyright holder.
'
'This software is provided WITHOUT warranty, either expressed or implied,
'including, but not limited to, the implied warranties of merchantability and
'fitness for a particular purpose. 
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->
<!--#include virtual="/Includes/inc-common.asp"-->

<%
'dimension variables
dim rsPages, sqlPages, intPagesCount, arrPagesData, rsFolder, sqlFolder, intFolderCount, arrFolderData, rsOrder, sqlOrder
dim objFSO, objPage
dim intPage, intPagesLoop, intFolderLoop, intBegin, intLength, intOrder, intOrderLoop
dim strContent, strDestination

'load and check variables
if request.querystring("Page") <> "" and isnumeric(request.querystring("Page")) = true then
	intPage = int(request.querystring("Page"))
end if

call validate_user()
%>

<title>Forest Site Administration</title>

<!--#include virtual="/Includes/inc-metadata.asp"-->

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/favicon.ico" />

<script language="javascript" type="text/javascript" src="<%=strSiteLocation%>/Includes/Tiny/tiny_mce.js"></script>
<script language="javascript" type="text/javascript">
	tinyMCE.init
	(
		{
			theme : "advanced",
			mode : "textareas",
			theme_advanced_containers : "mceControls,mceEditor",
			theme_advanced_container_mceControls:  'formatselect,separator,bold,italic,underline,strikethrough,separator,justifyleft,justifycenter,justifyright,justifyfull,outdent,indent,numlist,bullist,separator,link,unlink,anchor,image,separator,undo,redo,code,fullscreen',
			theme_advanced_layout_manager : "RowLayout",
			theme_advanced_toolbar_location : "top",
			remove_linebreaks : false,
			plugins : "codeprotect,fullscreen",
			convert_urls: false,
			entities : "",
			debug : false
		}
	);
</script>

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="content">
				<%
				'check whether a valid page has been specified
				if intPage = "" then
					
					'display edit page header
					response.write("<h1>Edit pages</h1>")
					
					'display edit page details
					response.write("<p>")
						response.write("The details of all of the pages currently defined in the Forest Site are listed below. Click on the appropriate edit link to edit the specified pages contents.")
					response.write("</p>")
					
					'grab all page details from the database
					set rsPages = server.createobject("adodb.recordset")
					sqlPages = "SELECT Page.Page_ID, Page.Page_Title, Folder.Folder_Title, Page.Page_URL FROM FS_Pages AS Page LEFT JOIN FS_Folders AS Folder ON Folder.Folder_ID = Page.Page_Folder_ID ORDER BY Page.Page_Order ASC;"
					rsPages.cursorlocation = 3
					rsPages.open sqlPages, adoConn
					if not (rsPages.bof or rsPages.eof) then
						intPagesCount = rsPages.recordcount
						arrPagesData = rsPages.getrows()
					else
						intPagesCount = 0
					end if
					rsPages.close
					set rsPages = nothing
					
					'increment query count
					intQuery = intQuery + 1
					
					'build table container
					response.write("<table cellspacing='0' summary='List of all the pages that exist within the database'>")
						
						'buid table header
						response.write("<tr>")
							
							response.write("<th>Page Title</th><th class='options'>Folder</th><th class='options'>Options</th>")
								
						response.write("</tr>")
						
						'initialise counter
						intPagesLoop = 0
						
						'loop through all pages
						do until intPagesLoop = intPagesCount
							
							response.write("<tr>")
								
								'display page title
								response.write("<td><a href='"& arrPagesData(3, intPagesLoop) &"' title='"& SQL_decode(arrPagesData(1, intPagesLoop)) &"' rel='external'>"& SQL_decode(arrPagesData(1, intPagesLoop)) &"</a></td>")
								
								'check for page parent
								if isnull(arrPagesData(2, intPagesLoop)) = true then
									response.write("<td class='options'>Root</td>")
								else
									response.write("<td class='options'>"& arrPagesData(2, intPagesLoop) &"</td>")
								end if
								
								response.write("<td class='options'><a href='page_edit.asp?Page="& arrPagesData(0, intPagesLoop) &"' title='Edit page'>Edit</a></td>")
																
							response.write("</tr>")
							
							'increment counter
							intPagesLoop = intPagesLoop + 1
						
						loop
						
					response.write("</table>")
					
				else
					
					'grab details of specified page
					set rsPages = server.createobject("adodb.recordset")
					sqlPages = "SELECT Page.Page_ID, Page.Page_Folder_ID, Page.Page_Type, Page.Page_Title, Page.Page_Image, Page.Page_Name, Page.Page_URL, Page.Page_Order, Folders.Folder_Title FROM FS_Pages AS Page LEFT JOIN FS_Folders AS Folders ON Page.Page_Folder_ID = Folders.Folder_ID WHERE Page.Page_ID = "& intPage &";"
					rsPages.cursorlocation = 3
					rsPages.open sqlPages, adoConn
					if not (rsPages.bof or rsPages.eof) then
						intPagesCount = rsPages.recordcount
						arrPagesData = rsPages.getrows()
					else
						intPagesCount = 0
					end if
					rsPages.close
					set rsPages= nothing
					
					'increment query count
					intQuery = intQuery + 1
					
					'check whether valid page was specified
					if intPagesCount = 0 then
						response.redirect("/Admin/error.asp?Type=Page&Error=Invalid&Redirect=/Admin/page_edit.asp")
					end if
					
					'check whether the page is a link page
					if arrPagesData(2, 0) = 1 then
						
						'display link page header
						response.write("<h1>Edit link page</h1>")
						
						'display link page details
						response.write("<p>")
							response.write("Use the form below to edit the specified page. Please pay attention to the description of each value and click submit once you have made the necassary changes.")
						response.write("</p>")
						
						'display link page form
						response.write("<form action='page_submit.asp' method='post' onsubmit=""this.submit.disabled=true;"">")
							
							response.write("<table cellspacing='0' summary='Form for adding editing link pages.'>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='title'><b>Page title</b></label>:<br />Sets the pages title, this is what will appear in all menus.</td>")
									response.write("<td class='details'><input id='title' name='title' type='text' value="""& SQL_decode(arrPagesData(3, 0)) &""" size='22' maxlength='200' tabindex='1' class='text' /></td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='image'><b>Page image</b></label>:<br />Sets the pages image, this is what will appear in all menus.</td>")
									response.write("<td class='details'><input id='image' name='image' type='text' value="""& SQL_decode(arrPagesData(4, 0)) &""" size='22' maxlength='200' tabindex='2' class='text' /></td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='address'><b>Page address</b></label>:<br />Sets the URL that the page links to.</td>")
									response.write("<td class='details'><input id='address' name='address' type='text' value="""& SQL_decode(arrPagesData(6, 0)) &""" size='22' maxlength='200' tabindex='3' class='text' /></td>")
								response.write("</tr>")
								
								'grab number of pages with the same parent
								set rsOrder = server.createobject("adodb.recordset")
								sqlOrder = "SELECT COUNT(*) AS intOrder FROM FS_Pages;"
								rsOrder.open sqlOrder, adoConn
								if not (rsOrder.bof or rsOrder.eof) then
									intOrder = cint(rsOrder("intOrder"))
								else
									intOrder = 0
								end if
								rsOrder.close
								set rsOrder = nothing
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='neworder'><b>Page order</b></label>:<br />Set the order in which the page should appear.</td>")
									response.write("<td class='details'>")
										
										response.write("<select id='neworder' name='neworder' tabindex='4' class='select'>")
											
											'initialise counter
											intOrderLoop = 0
											
											'loop through all available options
											do until intOrderLoop = intOrder
												
												'check for current order
												if intOrderLoop = arrPagesData(7, 0) then
													response.write("<option value="""& intOrderLoop &""" selected='selected'>"& intOrderLoop &"</option>")
												else
													response.write("<option value="""& intOrderLoop &""">"& intOrderLoop &"</option>")
												end if
												
												'increment counter
												intOrderLoop = intOrderLoop + 1
											
											loop
											
										response.write("</select>")
										
									response.write("</td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='delete'><b>Delete page</b></label>:<br />Tick this box to delete this page from the Forest Site.</td>")
									response.write("<td class='details'><input id='delete' name='delete' type='checkbox' tabindex='5' value=""1"" /></td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'></td>")
									response.write("<td class='details'><input name='type' type='hidden' value=""link"" /><input name='page' type='hidden' value="""& arrPagesData(0, 0) &""" /><input name='order' type='hidden' value="""& arrPagesData(7, 0) &""" /><input id='submit' name='submit' type='submit' tabindex='6' value=""Submit"" class='button' /></td>")
								response.write("</tr>")
								
							response.write("</table>")
							
						response.write("</form>")
						
					else
						
						'display physical page header
						response.write("<h1>Edit physical page</h1>")
						
						'display physical page details
						response.write("<p>")
							response.write("Use the form below to edit the specified page. Please pay attention to the description of each value and click submit once you have made the necassary changes.")
						response.write("</p>")
						
						'display physical page form
						response.write("<form action='page_submit.asp' method='post' onsubmit=""this.submit.disabled=true;"">")
							
							response.write("<table cellspacing='0' summary='Form for editing physical pages.'>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='folder'><b>Page folder</b></label>:<br /></td>")
									response.write("<td class='details'>")
									
										response.write("<input id='folder' name='folder' type='hidden' value="""& arrPagesData(1, 0) &""" />")
										
										'check for parent name
										if isnull(arrPagesData(8, 0)) = true then
											response.write("None")
										else
											response.write(arrPagesData(8, 0))
										end if
										
									response.write("</td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='title'><b>Page title</b></label>:<br />Sets the pages title, this is what will appear in all menus.</td>")
									response.write("<td class='details'><input id='title' name='title' type='text' value="""& SQL_decode(arrPagesData(3, 0)) &""" size='22' maxlength='200' tabindex='1' class='text' /></td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='name'><b>Page name</b></label>:<br />Sets the pages physical name, do not include any file extension as this will be added automatically.</td>")
									response.write("<td class='details'><input id='name' name='name' type='text' value="""& SQL_decode(arrPagesData(5, 0)) &""" size='22' maxlength='200' tabindex='2' readonly='readonly' class='text' /></td>")
								response.write("</tr>")
								
								'set physical page destination
								if arrPagesData(8, 0) = "" then
									strDestination = server.mappath("..") &"\"& arrPagesData(5, 0)
								else
									strDestination = server.mappath("..") &"\"& arrPagesData(8, 0) &"\"& arrPagesData(5, 0)
								end if
								
								'create file system object
								set objFSO = server.createobject("scripting.filesystemobject")
								
								'read in page to edit
								set objPage = objFSO.opentextfile(strDestination)
								strContent = objPage.readall
								set objPage = nothing
								
								'look up position begin editing tag, count from the begining of the template
								intBegin = instr(strContent, "<!--begin content-->") + 21
								
								'calculate length of content
								intLength = instr(strContent, "<!--end content-->") - intBegin
								
								'isolate editable content
								strContent = mid(strContent, intBegin, intLength)
								
								'close file system object
								set objFSO = nothing
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='text'><b>Page content</b></label>:<br />Sets the page content, you can enter any HTML or ASP code as long as it is within the appropriate tags.</td>")
									response.write("<td class='details'><textarea id='text' name='text' cols='' rows='10' tabindex='3' class='textarea'>"& strContent &"</textarea></td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='image'><b>Page image</b></label>:<br />Sets the pages image, this is what will appear in all menus.</td>")
									response.write("<td class='details'><input id='image' name='image' type='text' value="""& SQL_decode(arrPagesData(4, 0)) &""" size='22' maxlength='200' tabindex='4' class='text' /></td>")
								response.write("</tr>")
								
								'grab number of pages with the same 
								set rsOrder = server.createobject("adodb.recordset")
								sqlOrder = "SELECT COUNT(*) AS intOrder FROM FS_Pages;"								
								rsOrder.open sqlOrder, adoConn
								if not (rsOrder.bof or rsOrder.eof) then
									intOrder = cint(rsOrder("intOrder"))
								else
									intOrder = 0
								end if
								rsOrder.close
								set rsOrder = nothing
								
								'increment query count
								intQuery = intQuery + 1
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='neworder'><b>Page order</b></label>:<br />Set the order in which the page should appear.</td>")
									response.write("<td class='details'>")
										
										response.write("<select id='neworder' name='neworder' tabindex='5' class='select'>")
											
											'initialise counter
											intOrderLoop = 0
											
											'loop through all available options
											do until intOrderLoop = intOrder
												
												'check for current order
												if intOrderLoop = arrPagesData(7, 0) then
													response.write("<option value="""& intOrderLoop &""" selected='selected'>"& intOrderLoop &"</option>")
												else
													response.write("<option value="""& intOrderLoop &""">"& intOrderLoop &"</option>")
												end if
												
												'increment counter
												intOrderLoop = intOrderLoop + 1
											
											loop
											
										response.write("</select>")
										
									response.write("</td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='delete'><b>Delete page</b></label>:<br />Tick this box to delete this page from the Forest Site.</td>")
									response.write("<td class='details'><input id='delete' name='delete' type='checkbox' tabindex='6' value=""1"" /></td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'></td>")
									response.write("<td class='details'><input name='type' type='hidden' value=""physical"" /><input name='page' type='hidden' value="""& arrPagesData(0, 0) &""" /><input name='order' type='hidden' value="""& arrPagesData(7, 0) &""" /><input id='submit' name='submit' type='submit' tabindex='7' value=""Submit"" class='button' /></td>")
								response.write("</tr>")
								
							response.write("</table>")
							
						response.write("</form>")
						
					end if
					
				end if
				%>
			</div>
			
			<div id="subcontent">
				<%
				'display navigation
				call display_navigation()
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>