<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'All Host Forest software is provided for free under a linkware license.
'You may modify any part of the software at your own risk, but the software
'(altered or otherwise) may not be distributed to entities beyond the
'license holder without the explicit written permission of the copyright holder.
'
'You may not remove, alter or otherwise disable all or any of the hyperlinks
'to the Host Forest website (http://www.hostforest.co.uk). All images, links or
'text must remain unchanged and intact and visible when the pages are viewed
'unless you first obtain explicit written permission from the copyright holders.
'
'Permission to remove the links, images and branding on a site by site basis
'basis can be obtained by purchasing the appropriate license from Host Forest
'by visiting http://www.hostforest.co.uk/Purchase/default.asp 
'
'You may not pass of in part or in whole any part of this software, including
'images and source code, as your own work. You may use parts of this program in
'your own private works, including images and source code, but you may NOT
'redistribute, repackage, sublicense or sell in part or in whole any part of
'this program regardless of any modifications that may have been made without
'the express written permission of the copyright holder.
'
'This software is provided WITHOUT warranty, either expressed or implied,
'including, but not limited to, the implied warranties of merchantability and
'fitness for a particular purpose. 
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->
<!--#include virtual="/Includes/inc-common.asp"-->

<%
'dimension variables
dim rsPages, sqlPages, intPagesCount, arrPagesData
dim objFSO, objTemplate, objPage
dim intPage, intFolder, intOrder, intOrderNew, intOrderOld, intBegin, intEnd
dim strTitle, strName, strTemplate, strContent, strPage, strImage, strAddress, strLocation, strDestination

call validate_user()
%>

<title>Forest Site Administration</title>

<!--#include virtual="/Includes/inc-metadata.asp"-->

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/favicon.ico" />

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="content">
				<%
				select case request.form("type")
					
					case "link"
						
						if request.form("delete") = 1 then
							
							'load and check variables
							if request.form("page") <> "" and isnumeric(request.form("page")) = true then
								intPage = int(request.form("page"))
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Invalid&Redirect=/Admin/page_edit.asp")
							end if
							
							if request.form("order") <> "" and isnumeric(request.form("order")) = true then
								intOrder = int(request.form("order"))
							end if
							
							'delete specified page from database
							set rsPages = server.createobject("adodb.recordset")
							sqlPages = "DELETE FROM FS_Pages WHERE Page_ID = "& intPage &";"
							rsPages.cursortype = 2
							rsPages.locktype = 3
							rsPages.open sqlPages, adoConn
							set rsPages = nothing
							
							'increment query count
							intQuery = intQuery + 1
							
							'display confirmation
							response.write("<h1>Page deleted</h1>")
							
							response.write("<p>")
								response.write("The specified page has been successfully deleted. Please click <a href='"& strSiteLocation &"/Admin' title='Administration'>here</a> if you are not redirected within 5 seconds.")
							response.write("</p>")
							
							'set redirection
							response.addheader "Refresh", "5; URL="& strSiteLocation &"/Admin"
							
						else
							
							'load and check variables
							if request.form("page") <> "" and isnumeric(request.form("page")) = true then
								intPage = int(request.form("page"))
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Invalid&Redirect=/Admin/page_edit.asp")
							end if
							
							if clean_text(request.form("title"), 0) <> "" then
								strTitle = clean_text(request.form("title"), 0)
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Title&Redirect=/Admin/page_edit.asp?Page="& intPage)
							end if
							
							if clean_text(request.form("image"), 0) <> "" then
								strImage = clean_text(request.form("image"), 0)
							else
								strImage = NULL
							end if
							
							if clean_text(request.form("address"), 0) <> "" then
								if left(request.form("address"), 7) <> "http://" then
									strAddress = "http://"& clean_text(request.form("address"), 0)
								else
									strAddress = clean_text(request.form("address"), 0)
								end if
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Address&Redirect=/Admin/page_edit.asp?Page="& intPage)
							end if
							
							if request.form("neworder") <> "" and isnumeric(request.form("neworder")) = true then
								intOrderNew = int(request.form("neworder"))
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Order&Redirect=/Admin/page_edit.asp?Page="& intPage)
							end if
							
							if request.form("order") <> "" and isnumeric(request.form("order")) = true then
								intOrderOld = int(request.form("order"))
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Order&Redirect=/Admin/page_edit.asp?Page="& intPage)
							end if
							
							'update page details
							set rsPages = server.createobject("adodb.recordset")
							sqlPages = "UPDATE FS_Pages SET Page_Title = '"& strTitle &"', Page_Image = '"& strImage &"', Page_URL = '"& strAddress &"', Page_Order = "& intOrderNew &" WHERE Page_ID = "& intPage &";"
							rsPages.cursortype = 2
							rsPages.locktype = 3
							rsPages.open sqlPages, adoConn
							set rsPages = nothing
							
							'check whether page order has been changed
							if intOrderNew <> intOrderOld then
								
								'check whether new order is greater or smaller than current order
								if intOrderNew > intOrderOld then
									
									'update page orders
									set rsPages = server.createobject("adodb.recordset")
									sqlPages = "UPDATE FS_Pages SET Page_Order = (Page_Order - 1) WHERE Page_Order >= "& intOrderOld &" AND Page_Order <= "& intOrderNew &" AND Page_ID <> "& intPage &";"
									rsPages.cursortype = 2
									rsPages.locktype = 3
									rsPages.open sqlPages, adoConn
									set rsPages = nothing
									
								else
									
									'update page orders
									set rsPages = server.createobject("adodb.recordset")
									sqlPages = "UPDATE FS_Pages SET Page_Order = (Page_Order + 1) WHERE Page_Order >= "& intOrderNew &" AND Page_Order <= "& intOrderOld &" AND Page_ID <> "& intPage &";"
									rsPages.cursortype = 2
									rsPages.locktype = 3
									rsPages.open sqlPages, adoConn
									set rsPages = nothing
									
								end if
							
							end if
							
							'display confirmation
							response.write("<h1>Page updated</h1>")
							
							response.write("<p>")
								response.write("The specified page has been successfully updated. Please click <a href='"& strSiteLocation &"/Admin' title='Administration'>here</a> if you are not redirected within 5 seconds.")
							response.write("</p>")
							
							'set redirection
							response.addheader "Refresh", "5; URL="& strSiteLocation &"/Admin"
							
						end if
						
					case "physical"
						
						if request.form("delete") = 1 then
							
							'load and check variables
							if request.form("page") <> "" and isnumeric(request.form("page")) = true then
								intPage = int(request.form("page"))
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Invalid&Redirect=/Admin/page_edit.asp"& request.form("page"))
							end if
							
							if request.form("parent") = "NULL" or request.form("parent") = "" then
								intParent = "NULL"
							else
								if isnumeric(request.form("parent")) = true then
									intParent = int(request.form("parent"))
								else
									intParent = "NULL"
								end if
							end if
							
							if request.form("folder") <> "" and isnumeric(request.form("folder")) = true then
								intFolder = int(request.form("folder"))
							end if
							
							if request.form("order") <> "" and isnumeric(request.form("order")) = true then
								intOrder = int(request.form("order"))
							end if
							
							'check page does not have any child pages
							set rsPages = server.createobject("adodb.recordset")
							sqlPages = "SELECT * FROM FS_Pages WHERE Page_Parent_ID = "& intPage &";"
							rsPages.cursorlocation = 3
							rsPages.open sqlPages, adoConn
							if not (rsPages.bof or rsPages.eof) then
								intPagesCount = rsPages.recordcount
								arrPagesData = rsPages.getrows()
							else
								intPagesCount = 0
							end if
							rsPages.close
							set rsPages = nothing
							
							'increment query count
							intQuery = intQuery + 1
							
							if intPagesCount <> 0 then
								response.redirect("/Admin/error.asp?Type=Page&Error=Children&Redirect=/Admin/page_edit.asp")
							end if
							
							'grab page and folder details
							set rsPages = server.createobject("adodb.recordset")
							sqlPages = "SELECT Page.Page_ID, Page.Page_Name, Page.Page_Protected, Folders.Folder_Title FROM FS_Pages AS Page LEFT JOIN FS_Folders AS Folders ON Page.Page_Folder_ID = Folders.Folder_ID WHERE Page.Page_ID = "& intPage &";"
							rsPages.cursorlocation = 3
							rsPages.open sqlPages, adoConn
							intPagesCount = rsPages.recordcount
							arrPagesData = rsPages.getrows()
							rsPages.close
							set rsPages = nothing
							
							'increment query count
							intQuery = intQuery + 1
							
							'check page is not protected
							if arrPagesData(2, 0) = 1 then
								response.redirect("/Admin/error.asp?Type=Page&Error=Children&Redirect=/Admin/page_edit.asp")
							end if
							
							'delete specified page from database
							set rsPages = server.createobject("adodb.recordset")
							sqlPages = "DELETE FROM FS_Pages WHERE Page_ID = "& intPage &";"
							rsPages.cursortype = 2
							rsPages.locktype = 3
							rsPages.open sqlPages, adoConn
							set rsPages = nothing
							
							'increment query count
							intQuery = intQuery + 1
							
							'check whether this is a root page
							if intParent = "NULL" then
								
								'update the order of all root pages
								set rsPages = server.createobject("adodb.recordset")
								sqlPages = "UPDATE FS_Pages SET Page_Order = (Page_Order - 1) WHERE Page_Order > "& intOrder &" AND Page_Parent_ID IS NULL;"
								rsPages.cursortype = 2
								rsPages.locktype = 3
								rsPages.open sqlPages, adoConn
								set rsPages= nothing
								
								'increment query count
								intQuery = intQuery  + 1
								
							else
								
								'update the order of all child pages
								set rsPages = server.createobject("adodb.recordset")
								sqlPages = "UPDATE FS_Pages SET Page_Order = (Page_Order - 1) WHERE Page_Order > "& intOrder &" AND Page_Parent_ID = "& intParent &";"
								rsPages.cursortype = 2
								rsPages.locktype = 3
								rsPages.open sqlPages, adoConn
								set rsPages= nothing
								
								'increment query count
								intQuery = intQuery  + 1
								
							end if
							
							'check whether the page is in a folder
							if isnull(arrPagesData(3, 0)) = true then
								'set page destination
								strDestination = server.mappath("..") &"\"& arrPagesData(1, 0)
							else
								'set page destination
								strDestination = server.mappath("..") &"\"& arrPagesData(3, 0) &"\"& arrPagesData(1, 0)
							end if
							
							'create file system object
							set objFSO = server.createobject("scripting.filesystemobject")
								
							'delete page
							if objFSO.fileexists(strDestination) = true then
								objFSO.deletefile(strDestination)
							end if
							
							'clean up
							set objFSO = nothing
							
							'display confirmation
							response.write("<h1>Page deleted</h1>")
							
							response.write("<p>")
								response.write("The specified page has been successfully deleted. Please click <a href='"& strSiteLocation &"/Admin' title='Administration'>here</a> if you are not redirected within 5 seconds.")
							response.write("</p>")
							
							'set redirection
							response.addheader "Refresh", "5; URL="& strSiteLocation &"/Admin"
							
						else
							
							'load and check variables
							if request.form("page") <> "" and isnumeric(request.form("page")) = true then
								intPage = int(request.form("page"))
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Invalid&Redirect=/Admin/page_edit.asp")
							end if
							
							if clean_text(request.form("title"), 0) <> "" then
								strTitle = clean_text(request.form("title"), 0)
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Title&Redirect=/Admin/page_edit.asp?Page="& intPage)
							end if
							
							strContent = request.form("text")
							
							if clean_text(request.form("image"), 0) <> "" then
								strImage = clean_text(request.form("image"), 0)
							else
								strImage = NULL
							end if
							
							if clean_text(request.form("image"), 0) <> "" then
								strImage = clean_text(request.form("image"), 0)
							else
								strImage = NULL
							end if
							
							if request.form("neworder") <> "" and isnumeric(request.form("neworder")) = true then
								intOrderNew = int(request.form("neworder"))
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Order&Redirect=/Admin/page_edit.asp?Page="& intPage)
							end if
							
							if request.form("order") <> "" and isnumeric(request.form("order")) = true then
								intOrderOld = int(request.form("order"))
							else
								response.redirect("/Admin/error.asp?Type=Page&Error=Order&Redirect=/Admin/page_edit.asp?Page="& intPage)
							end if
							
							'grab page and folder details
							set rsPages = server.createobject("adodb.recordset")
							sqlPages = "SELECT Page.Page_ID, Page.Page_Name, Folders.Folder_Title FROM FS_Pages AS Page LEFT JOIN FS_Folders AS Folders ON Page.Page_Folder_ID = Folders.Folder_ID WHERE Page.Page_ID = "& intPage &";"
							rsPages.cursorlocation = 3
							rsPages.open sqlPages, adoConn
							intPagesCount = rsPages.recordcount
							arrPagesData = rsPages.getrows()
							rsPages.close
							set rsPages = nothing
							
							'increment query count
							intQuery = intQuery + 1
							
							'update page details
							set rsPages = server.createobject("adodb.recordset")
							sqlPages = "UPDATE FS_Pages SET Page_Title = '"& strTitle &"', Page_Image = '"& strImage &"', Page_Order = "& intOrderNew &" WHERE Page_ID = "& intPage &";"
							rsPages.cursortype = 2
							rsPages.locktype = 3
							rsPages.open sqlPages, adoConn
							set rsPages = nothing
							
							'check whether page order has been changed
							if intOrderNew <> intOrderOld then
								
								'check whether new order is greater or smaller than current order
								if intOrderNew > intOrderOld then
									
									'update page orders
									set rsPages = server.createobject("adodb.recordset")
									sqlPages = "UPDATE FS_Pages SET Page_Order = (Page_Order - 1) WHERE Page_Order >= "& intOrderOld &" AND Page_Order <= "& intOrderNew &" AND Page_ID <> "& intPage &";"
									rsPages.cursortype = 2
									rsPages.locktype = 3
									rsPages.open sqlPages, adoConn
									set rsPages = nothing
									
								else
									
									'update page orders
									set rsPages = server.createobject("adodb.recordset")
									sqlPages = "UPDATE FS_Pages SET Page_Order = (Page_Order + 1) WHERE Page_Order >= "& intOrderNew &" AND Page_Order <= "& intOrderOld &" AND Page_ID <> "& intPage &";"
									rsPages.cursortype = 2
									rsPages.locktype = 3
									rsPages.open sqlPages, adoConn
									set rsPages = nothing
									
								end if
							
							end if
							
							'check whether the page is in a folder
							if isnull(arrPagesData(2, 0)) = true then
								'set page destination
								strDestination = server.mappath("..") &"\"& arrPagesData(1, 0)
							else
								'set page destination
								strDestination = server.mappath("..") &"\"& arrPagesData(2, 0) &"\"& arrPagesData(1, 0)
							end if
							
							'create file system object
							set objFSO= server.createobject("scripting.filesystemobject")
							
							'read in template page
							set objTemplate = objFSO.opentextfile(server.mappath("..") &"/Includes/template-page.asp")
							strTemplate = objTemplate.readall
							set objTemplate = nothing
							
							'look up position begin editing tag, count from the begining of the template
							intBegin = instr(strTemplate, "<!--begin content-->") + 21
							
							'look up position end editing tag, count from the end of the template
							intEnd = len(strTemplate) - instr(strTemplate, "<!--end content-->") + 1
							
							'insert page content
							strPage = left(strTemplate, intBegin) & strContent & vbcrlf & right(strTemplate, intEnd)
							
							'replace page title
							strPage = replace(strPage, "{TITLE}", strTitle)
							
							'write new page
							set objPage = objFSO.createtextfile(strDestination)
							objPage.writeline(strPage)
							objPage.close
							set objPage = nothing
							
							'close file system object
							set objFSO = nothing
							
							'display confirmation
							response.write("<h1>Page updated</h1>")
							
							response.write("<p>")
								response.write("The specified page has been successfully updated. Please click <a href='"& strSiteLocation &"/Admin' title='Administration'>here</a> if you are not redirected within 5 seconds.")
							response.write("</p>")
							
							'set redirection
							response.addheader "Refresh", "5; URL="& strSiteLocation &"/Admin"
							
						end if
						
					case else
						
						response.redirect("/Admin/error.asp?Type=Page&Error=Invalid&Redirect=/Admin/page_edit.asp")
						
				end select
				%>
			</div>
			
			<div id="subcontent">
				<%
				'display navigation
				call display_navigation()
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>