<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'This software if free provided under a linkware license.
'you may modify any part of the software at your own risk
'under the license that accompanies it.
'
'You may not remove, alter or otherwise disable all or any of 
'the hyperlinks to the Host Forest website (http://www.hostforest.co.uk).
'
'All images, links or text must remain unchanged and intact and visible
'when the pages are viewed unless you first obtain explicit written
'permission from the copyright holders.
'
'This software is provided WITHOUT warranty, with the implied warranty
'of merchantability, fitness for purpose or any other wannaties whether
'expressed or implied.
'
'Support for the forums is provided at http://www.hostforest.co.uk/forums
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->
<!--#include virtual="/Includes/inc-common.asp"-->

<%
'dimension variables
dim objFSO, objFooter, objTemplate
dim intBegin, intEnd, intLength
dim strContent, strDestination, strFooter, strTemplate

call validate_user()
%>

<title>Forest Site Administration</title>

<!--#include virtual="/Includes/inc-metadata.asp"-->

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/favicon.ico" />

<script language="javascript" type="text/javascript" src="<%=strSiteLocation%>/Includes/Tiny/tiny_mce.js"></script>
<script language="javascript" type="text/javascript">
	tinyMCE.init
	(
		{
			theme : "advanced",
			mode : "textareas",
			theme_advanced_containers : "mceControls,mceEditor",
			theme_advanced_container_mceControls:  'formatselect,separator,bold,italic,underline,strikethrough,separator,justifyleft,justifycenter,justifyright,justifyfull,outdent,indent,numlist,bullist,separator,link,unlink,anchor,image,separator,undo,redo,code,fullscreen',
			theme_advanced_layout_manager : "RowLayout",
			theme_advanced_toolbar_location : "top",
			remove_linebreaks : false,
			plugins : "codeprotect,fullscreen",
			convert_urls: false,
			entities : "",
			debug : false
		}
	);
</script>

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="content">
				<%
				'check page has not been submitted
				if request.form = "" then
					
					'display header
					response.write("<h1>Edit footer</h1>")
					
					response.write("<p>")
						response.write("Please use the form below to edit the footer of your Forest Site installation. Any changes made to the footer will be presented on all pages throughout your Forest Site installation.")
					response.write("</p>")
					
					'display edit header form
					response.write("<form action='settings_footer.asp' method='post' onsubmit=""this.submit.disabled=true;"">")
						
						response.write("<table cellspacing='0' summary='Form for editing Forest Site footer.'>")
							
							'set physical page destination
							strDestination = server.mappath("..") &"\Includes\inc-footer.asp"
							
							'create file system object
							set objFSO = server.createobject("scripting.filesystemobject")
							
							'read in page to edit
							set objFooter = objFSO.opentextfile(strDestination)
							strContent = objFooter.readall
							set objFooter = nothing
							
							'look up position begin editing tag, count from the begining of the template
							intBegin = instr(strContent, "<!--begin footer-->") + 20
							
							'calculate length of content
							intLength = instr(strContent, "<!--end footer-->") - intBegin
							
							'isolate editable content
							strContent = mid(strContent, intBegin, intLength)
							
							'close file system object
							set objFSO = nothing
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='text'><b>Footer content</b></label>:<br />Sets the footer contents. You can use any HTML or ASP code as long as it is within the appropriate tags.</td>")
								response.write("<td class='details'><textarea id='text' name='text' cols='' rows='10' tabindex='1' class='textarea'>"& strContent &"</textarea></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'></td>")
								response.write("<td class='details'><input id='submit' name='submit' type='submit' tabindex='2' value=""Submit"" class='button' /></td>")
							response.write("</tr>")
							
						response.write("</table>")
						
					response.write("</form>")
					
				else
					
					'load variables
					strContent = request.form("text")
					strDestination = server.mappath("..") &"\Includes\inc-footer.asp"
					
					'create file system object
					set objFSO= server.createobject("scripting.filesystemobject")
					
					'read in template page
					set objTemplate = objFSO.opentextfile(server.mappath("..") &"/Includes/template-footer.asp")
					strTemplate = objTemplate.readall
					set objTemplate = nothing
					
					'look up position begin editing tag, count from the begining of the template
					intBegin = instr(strTemplate, "<!--begin footer-->") + 20
					
					'look up position end editing tag, count from the end of the template
					intEnd = len(strTemplate) - instr(strTemplate, "<!--end footer-->") + 1
					
					'insert page content
					strFooter = left(strTemplate, intBegin) & strContent & vbcrlf & right(strTemplate, intEnd)
					
					'write new page
					set objFooter = objFSO.createtextfile(strDestination)
					objFooter.writeline(strFooter)
					objFooter.close
					set objFooter = nothing
					
					'close file system object
					set objFSO = nothing
					
					'display confirmation
					response.write("<h1>Footer updated</h1>")
					
					response.write("<p>")
						response.write("The footer has been successfully updated. Please click <a href='"& strSiteLocation &"/Admin' title='Administration'>here</a> if you are not redirected within 5 seconds.")
					response.write("</p>")
					
					'set redirection
					response.addheader "Refresh", "5; URL="& strSiteLocation &"/Admin"
					
				end if
				%>
			</div>
			
			<div id="subcontent">
				<%
				'display navigation
				call display_navigation()
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>