<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'This software if free provided under a linkware license.
'you may modify any part of the software at your own risk
'under the license that accompanies it.
'
'You may not remove, alter or otherwise disable all or any of 
'the hyperlinks to the Host Forest website (http://www.hostforest.co.uk).
'
'All images, links or text must remain unchanged and intact and visible
'when the pages are viewed unless you first obtain explicit written
'permission from the copyright holders.
'
'This software is provided WITHOUT warranty, with the implied warranty
'of merchantability, fitness for purpose or any other wannaties whether
'expressed or implied.
'
'Support for the forums is provided at http://www.hostforest.co.uk/forums
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->
<!--#include virtual="/Includes/inc-common.asp"-->

<%
'dimension variables
dim xmlHTTP, xmlDOM, rssFeed, rssItems, rssItem, rssTitle, rssLink, rssDate, rssDescription
dim strTemplate, strContent
dim intRSSCount, intRSSLoop, intRSSStatus, intChild

call validate_user()
%>

<title>Forest Site Administration</title>

<!--#include virtual="/Includes/inc-metadata.asp"-->

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/favicon.ico" />

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="content">
				<%
				'display header
				response.write("<h1>Administration panel</h1>")
				
				'display welcome message
				response.write("<p>")
					response.write("Hi "& SQL_decode(session("FS_UserName")) &" and welcome back to the Forest Site administration panel.")
				response.write("</p>")
				
				response.write("<p>")
					response.write("Please select any option from the menu on the right to make the appropriate changes to your account or the website.")
				response.write("</p>")
				
				response.write("<h2>Host Forest News</h2>")
				
				response.write("<p>")
					response.write("Below is the latest news from the <a href='http://www.hostforest.co.uk' title='Host Forest' rel='external'>Host Forest</a> development website. Click on the title to view the full article antry.")
				response.write("</p>")
				
				'create xmlHTTP object and grab specified feed
				set xmlHTTP = server.createobject("MSXML2.XMLHTTP.4.0")
				xmlHTTP.open "Get", "http://www.hostforest.co.uk/rss.asp", false
				xmlHTTP.Send()
				rssFeed = xmlHTTP.ResponseText
				intRSSStatus = xmlHTTP.status
				
				'check feed has been returned
				if intRSSStatus = 200 then
				
					'create xmlDOM element and load specified feed
					set xmlDOM = server.createobject("MSXML2.DomDocument.4.0")
					xmlDOM.async = false
					xmlDOM.loadXML(rssFeed)
					
					'collect all "items" from downloaded RSS
					set rssItems = xmlDOM.getElementsByTagName("item")
					
					'clean up
					set xmlDOM = nothing
					
					'count items
					intRSSCount = rssItems.Length
					
					'initialise counter
					intRSSLoop = 0
					
					'loop through each node
					do until intRSSLoop = intRSSCount
					
						'set current node
						set RSSItem = rssItems.Item(intRSSLoop)
						
						'loop through child elements
						for each intChild in RSSItem.childNodes
							
							'assign variables dependant on child node
							select case lcase(intChild.nodeName)
								
								case "title"
									rssTitle = SQL_encode(intChild.text)
									
								case "link"
									rssLink = intChild.text
									
								case "description"
									rssDescription = intChild.text
								
								case "pubdate"
									rssDate = intChild.text
									
							end select
							
						next
						
						'display article
						response.write("<div class='article'>")
							
							'display heaeder
							response.write("<h3 class='articleheader'><a href='"& rssLink &"' title='"& rssTitle &"' rel='external'>"& rssTitle &"</a></h3>")
							
							'display details
							response.write("<ul class='articledetails'>")
								response.write("<li><b>Date</b>: "& rssDate &"</li>")
							response.write("</ul>")
							
							'display article
							response.write(rssDescription)
							
						response.write("</div>")
						
						'increment couner
						intRSSLoop = intRSSLoop + 1
						
					loop
					
				else
					
					'display error
					response.write("<div class='article'>")
						
						response.write("<h3 class='articleheader'>News error</h3>")
						
						response.write("<p>")
							response.write("There was an error retreiving the default Host Forest news feed. Please visit the official <a href='http://www.hostforest.co.uk' title='Host Forest' rel='external'>Host Forest</a> website for the latest news on the Forest Site software.")
						response.write("</p>")
						
					response.write("</div>")
					
				end if
				
				'clean up
				set xmlHTTP = nothing
				%>
			</div>
			
			<div id="subcontent">
				<%
				'display navigation
				call display_navigation()
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>