<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'All Host Forest software is provided for free under a linkware license.
'You may modify any part of the software at your own risk, but the software
'(altered or otherwise) may not be distributed to entities beyond the
'license holder without the explicit written permission of the copyright holder.
'
'You may not remove, alter or otherwise disable all or any of the hyperlinks
'to the Host Forest website (http://www.hostforest.co.uk). All images, links or
'text must remain unchanged and intact and visible when the pages are viewed
'unless you first obtain explicit written permission from the copyright holders.
'
'Permission to remove the links, images and branding on a site by site basis
'basis can be obtained by purchasing the appropriate license from Host Forest
'by visiting http://www.hostforest.co.uk/Purchase/default.asp 
'
'You may not pass of in part or in whole any part of this software, including
'images and source code, as your own work. You may use parts of this program in
'your own private works, including images and source code, but you may NOT
'redistribute, repackage, sublicense or sell in part or in whole any part of
'this program regardless of any modifications that may have been made without
'the express written permission of the copyright holder.
'
'This software is provided WITHOUT warranty, either expressed or implied,
'including, but not limited to, the implied warranties of merchantability and
'fitness for a particular purpose. 
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->

<%
'dimension variables
dim rsLogin, sqlLogin, intLoginCount, arrLoginData
dim strUsername, strPassword, strHeader, strMessage, strAddress, strRedirect

'load and check variables
strUsername = clean_text(request.form("name"), 0)
strPassword = clean_text(request.form("password"), 0)
%>

<title>Forest Site Administration</title>

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/favicon.ico" />

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="login">
				<%
				'check whether user is logged in		
				if session("FS_UserID") = "" then
					
					'check whether user has enetered any user details
					if (strUsername = "" and strUsername <> "name") and (strPassword = "" and strPassword <> "password") then
					
						'display login header
						response.write("<h1>Forest Site Login</h1>")
						
						'display login message
						response.write("<p>")
							response.write("Please enter your user login details below to log in to the Forest Site Administration panel. Please click <a href='reminder.asp' title='Reminder'>here</a> if you have forgotten your details and need a password reminder.")
						response.write("</p>")
						
						'display login form
						response.write("<form action='login.asp' method='post' onsubmit=""this.submit.disabled=true;"">")
							
							response.write("<p>")
								response.write("<label for='name'>Username</label> <input id='name' name='name' type='text' value=""name"" size='22' maxlength='80' tabindex='1' onfocus=""this.value=''"" /> <label for='password'>Password</label> <input id='password' name='password' type='password' value=""password"" size='22' maxlength='80' tabindex='2' onfocus=""this.value=''"" /> <input id='submit' name='submit' type='submit' tabindex='3' value=""Submit"" class='button' />")
							response.write("</p>")
							
						response.write("</form>")
						
					else
						
						'grab details for the specified user name
						set rsLogin = server.createobject("adodb.recordset")
						sqlLogin = "SELECT User_ID, User_Name, User_Password FROM FS_Users WHERE User_Name = '"& strUsername &"';"
						rsLogin.cursorlocation = 3
						rsLogin.open sqlLogin, adoConn
						if not (rsLogin.bof or rsLogin.eof) then
							intLoginCount = rsLogin.recordcount
							arrLoginData = rsLogin.getrows()
						else
							intLoginCount = 0
						end if
						rsLogin.close
						set rsLogin = nothing
						
						'increment query count
						intQuery = intQuery + 1
						
						'check a valid user has been specified
						if intLoginCount = 0 then
							
							'set error message
							strHeader = "Login error"
							strMessage = "<p>The username and/or password that you have enetered is incorrect.</p>"
							strRedirect = strSiteLocation &"/default.asp"
							
						else
							
							'check that the correct password has been specified
							if arrLoginData(2, 0) <> strPassword then
								
								'set error message
								strHeader = "Login error"
								strMessage = "<p>The password that you have entered is incorrect. Please verify your login details are corect and log in again.</p>"
								strRedirect = strSiteLocation &"/default.asp"
								
							else
								
								'set session variables
								session("FS_UserID") = arrLoginData(0, 0)
								session("FS_UserName") = arrLoginData(1, 0)		
								
								'set user IP address
								if request.servervariables("HTTP_X_FORWARDED_FOR") = "" then
									strAddress = request.servervariables("REMOTE_ADDR")
								else
									strAddress = request.servervariables("HTTP_X_FORWARDED_FOR")
								end If
								
								'update users details
								set rsLogin = server.createobject("adodb.recordset")
								sqlLogin = "UPDATE FS_Users SET User_Address = '"& strAddress &"', User_Login = (User_Login + 1) WHERE User_ID = "& arrLoginData(0, 0) &";"
								rsLogin.cursortype = 2
								rsLogin.locktype = 3
								rsLogin.open sqlLogin, adoConn
								set rsLogin = nothing
								
								'increment query count
								intQuery = intQuery + 1
								
								'set confirmation message
								strHeader = "Login successful"
								strMessage = "<p>Thank you, your login was successful.</p>"
								
								'set redirection
								strRedirect = strSiteLocation &"/Admin/default.asp"
								
							end if
							
						end if 
						
					end if
					
				else
					
					'clear session variables
					session.abandon()
					
					'set confirmarion message
					strHeader = "Logout successful"
					strMessage = "<p>You have been logged out of successfully.</p>"
					strRedirect = strSiteLocation &"/default.asp"
					
				end if
				
				'check whether to display message
				if strHeader <> "" then
				
					'display login/logout messages
					response.write("<h1>"& strHeader &"</h1>")
					
					response.write(strMessage)
					
					response.write("<p>")
						response.write("Please click <a href='"& strRedirect &"' title='"& strSiteTitle &"'>here</a> if you are not redirected within 5 seconds.")
					response.write("</p>")
					
					response.addheader "Refresh", "5; URL="& strRedirect
					
				end if
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>