<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'All Host Forest software is provided for free under a linkware license.
'You may modify any part of the software at your own risk, but the software
'(altered or otherwise) may not be distributed to entities beyond the
'license holder without the explicit written permission of the copyright holder.
'
'You may not remove, alter or otherwise disable all or any of the hyperlinks
'to the Host Forest website (http://www.hostforest.co.uk). All images, links or
'text must remain unchanged and intact and visible when the pages are viewed
'unless you first obtain explicit written permission from the copyright holders.
'
'Permission to remove the links, images and branding on a site by site basis
'basis can be obtained by purchasing the appropriate license from Host Forest
'by visiting http://www.hostforest.co.uk/Purchase/default.asp 
'
'You may not pass of in part or in whole any part of this software, including
'images and source code, as your own work. You may use parts of this program in
'your own private works, including images and source code, but you may NOT
'redistribute, repackage, sublicense or sell in part or in whole any part of
'this program regardless of any modifications that may have been made without
'the express written permission of the copyright holder.
'
'This software is provided WITHOUT warranty, either expressed or implied,
'including, but not limited to, the implied warranties of merchantability and
'fitness for a particular purpose. 
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->
<!--#include virtual="/Includes/inc-common.asp"-->

<%
'dimension variables
dim rsSettings, sqlSettings
dim fso, fsoFolderRoot, fsoFolderSub
dim strDirectory, strName, strDescription, strTheme, strLocation, strMetaKeywords, strMetaDescription
dim intFolders

call validate_user()
%>

<title>Forest Site Administration</title>

<!--#include virtual="/Includes/inc-metadata.asp"-->

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/favicon.ico" />

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="content">
				<%
				'check form has been submitted
				if request.form = "" then
					
					'display settings header
					response.write("<h1>General settings</h1>")
					
					'display settings details
					response.write("<p>")
						response.write("Use the form below to set the default settings for the Forest Site. Please pay attention to the description of each value and click submit once you have made the necassary changes.")
					response.write("</p>")
					
					'build settings form
					response.write("<form action='settings_general.asp' method='post' onsubmit=""this.submit.disabled=true;"">")
						
						response.write("<table cellspacing='0' summary='Form for editing general settings.'>")							
														
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='name'><b>Site name</b></label>:<br />The name of your website.</td>")
								response.write("<td class='details'><input id='name' name='name' type='text' value="""& strSiteTitle &""" size='22' maxlength='200' tabindex='1' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='description'><b>Site description</b></label>:<br />A description of your website.</td>")
								response.write("<td class='details'><input id='description' name='description' type='text' value="""& strSiteDescription &""" size='22' maxlength='200' tabindex='2' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='theme'><b>Site theme</b></label>:<br />Sets the current theme for your website.</td>")
								response.write("<td class='details'>")
									
									'set Themes directory	
									strDirectory = server.mappath("..") &"\Themes\"
									
									'grab themes folder details
									set fso = server.createobject("scripting.fileSystemobject")
									set fsoFolderRoot = fso.GetFolder(strDirectory)
									set fsoFolderSub = fsoFolderRoot.SubFolders
										
									response.write("<select id='theme' name='theme' class='select' tabindex='3'>")
										
										'loop through all theme directories
										for each intFolders in fsoFolderSub
											if intFolders.name = strTheme then
												response.write "<option value="""& intFolders.Name &""" selected='selected'>"& intFolders.Name &"</option>"
											else
												response.write "<option value="""& intFolders.Name &""">"& intFolders.Name &"</option>"
											end if
										next
										
									response.write("</select>")
									
								response.write("</td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='location'><b>Site location</b></label>:<br />Sets the base URL of your website, <i>do NOT include a trailing /</i>.</td>")
								response.write("<td class='details'><input id='location' name='location' type='text' value="""& strSiteLocation &""" size='22' maxlength='200' tabindex='4' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='metakeywords'><b>Meta keywords</b></label>:<br />The sites meta keywords, inserted on every page.</td>")
								response.write("<td class='details'><input id='metakeywords' name='metakeywords' type='text' value="""& strSiteMetaKeywords &""" size='22' maxlength='200' tabindex='5' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='metadescription'><b>Meta description</b></label>:<br />The sites meta description, inserted on every page. <i>Do not use HTML tags</i>.</td>")
								response.write("<td class='details'><textarea id='metadescription' name='metadescription' cols='' rows='10' tabindex='6' class='textarea'>"& strSiteMetaDescription &"</textarea></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'></td>")
								response.write("<td class='details'><input id='submit' name='submit' type='submit' tabindex='7' value=""Submit"" class='button' /></td>")
							response.write("</tr>")
							
						response.write("</table>")
						
					response.write("</form>")
					
				else
					
					'load and check variables					
					if clean_text(request.form("name"), 0) <> "" then
						strName = clean_text(request.form("name"), 0)
					else
						response.redirect("/Admin/error.asp?Type=General&Error=Name&Redirect=/Admin/settings_general.asp")
					end if
					
					if clean_text(request.form("description"), 0) <> "" then
						strDescription = clean_text(request.form("description"), 0)
					else
						strDescription = NULL
					end if
					
					if clean_text(request.form("theme"), 0) <> "" then
						strTheme = clean_text(request.form("theme"), 0)
					else
						response.redirect("/Admin/error.asp?Type=General&Error=Theme&Redirect=/Admin/settings_general.asp")
					end if
					
					if clean_text(request.form("location"), 0) <> "" then
						if left(request.form("location"), 7) <> "http://" then
							strLocation = "http://"& request.form("location")
						else
							strLocation = request.form("location")
						end if
					else
						response.redirect("/Admin/error.asp?Type=General&Error=Location&Redirect=/Admin/settings_general.asp")
					end if
					
					if clean_text(request.form("metakeywords"), 0) <> "" then
						strMetaKeywords = clean_text(request.form("metakeywords"), 0)
					else
						strMetaKeywords = NULL
					end if
					
					if clean_text(request.form("metadescription"), 0) <> "" then
						strMetaDescription = clean_text(request.form("metadescription"), 0)
					else
						strMetaDescription = NULL
					end if
					
					'update general settings
					set rsSettings = server.createobject("adodb.recordset")
					sqlSettings = "UPDATE FS_Configuration SET Site_Name = '"& strName &"', Site_Description = '"& strDescription &"', Site_Theme = '"& strTheme &"', Site_Location = '"& strLocation &"', Site_Meta_Keywords = '"& strMetaKeywords &"', Site_Meta_Description ='"& strMetaDescription &"';"
					rsSettings.cursortype = 2
					rsSettings.locktype = 3
					rsSettings.open sqlSettings, adoConn
					set rsSettings = nothing
					
					'increment query count
					intQuery = intQuery + 1
					
					'display confirmation
					response.write("<h1>General settings updated</h1>")
					
					response.write("<p>")
						response.write("The general settings have been successfully updated. Please click <a href='"& strSiteLocation &"/Admin' title='Administration'>here</a> if you are not redirected within 5 seconds.")
					response.write("</p>")
					
					'set redirection
					response.addheader "Refresh", "5; URL="& strSiteLocation &"/Admin"
					
				end if
				%>
			</div>
			
			<div id="subcontent">
				<%
				'display navigation
				call display_navigation()
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>