<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'All Host Forest software is provided for free under a linkware license.
'You may modify any part of the software at your own risk, but the software
'(altered or otherwise) may not be distributed to entities beyond the
'license holder without the explicit written permission of the copyright holder.
'
'You may not remove, alter or otherwise disable all or any of the hyperlinks
'to the Host Forest website (http://www.hostforest.co.uk). All images, links or
'text must remain unchanged and intact and visible when the pages are viewed
'unless you first obtain explicit written permission from the copyright holders.
'
'Permission to remove the links, images and branding on a site by site basis
'basis can be obtained by purchasing the appropriate license from Host Forest
'by visiting http://www.hostforest.co.uk/Purchase/default.asp 
'
'You may not pass of in part or in whole any part of this software, including
'images and source code, as your own work. You may use parts of this program in
'your own private works, including images and source code, but you may NOT
'redistribute, repackage, sublicense or sell in part or in whole any part of
'this program regardless of any modifications that may have been made without
'the express written permission of the copyright holder.
'
'This software is provided WITHOUT warranty, either expressed or implied,
'including, but not limited to, the implied warranties of merchantability and
'fitness for a particular purpose. 
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->
<!--#include virtual="/Includes/inc-common.asp"-->

<%
'dimension variables
dim rsUsers, sqlUsers, intUsersCount, arrUsersData
dim strUser
dim intUser, intUsersLoop

'load and check variables
if request.querystring("User") <> "" and isnumeric(request.querystring("User")) = true then
	intUser = int(request.querystring("User"))
end if

if clean_text(request.querystring("Name"), 0) <> "" then
	strUser = clean_text(request.querystring("Name"), 0)
end if

call validate_user()
%>

<title>Forest Site Administration</title>

<!--#include virtual="/Includes/inc-metadata.asp"-->

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/favicon.ico" />

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="content">
				<%
				'check whether a user has been selected
				if intUser = "" and strUser = "" then
					
					'display users header
					response.write("<h1>Edit users</h1>")
					
					'display users details
					response.write("<p>")
						response.write("The details of all of the user accounts, excluding your own, registered with Forest site are listed  below. Click on the appropriate edit link to edit the specified users details.")
					response.write("</p>")
					
					'grab last 50 registered users
					set rsUsers = server.createobject("adodb.recordset")
					sqlUsers = "SELECT User_ID, User_Name FROM FS_Users WHERE User_ID <> "& session("FS_UserID") &" ORDER BY User_Name ASC;"
					rsUsers.cursorlocation = 3
					rsUsers.open sqlUsers, adoConn
					if not (rsUsers.bof or rsUsers.eof) then
						intUsersCount = rsUsers.recordcount
						arrUsersData = rsUsers.getrows()
					else
						intUsersCount = 0
					end if
					rsUsers.close
					set rsUsers = nothing
					
					'increment query count
					intQuery = intQuery + 1
					
					'build table container
					response.write("<table cellspacing='0' summary='List of all Forest Site users to edit.'>")
						
						'buid table header
						response.write("<tr>")
							
							response.write("<th>Username</th><th class='options'>Options</th>")
								
						response.write("</tr>")
						
						'initialise counter
						intUsersLoop = 0
						
						'loop throug all categories
						do until intUsersLoop = intUsersCount
							
							response.write("<tr>")
							
								response.write("<td>"& SQL_decode(arrUsersData(1, intUsersLoop)) &"</td><td class='options'><a href='users_edit.asp?User="& arrUsersData(0, intUsersLoop) &"' title='Edit user'>Edit</a></td>")
									
							response.write("</tr>")
							
							'increment query count
							intUsersLoop = intUsersLoop + 1
							
						loop
						
					response.write("</table>")
					
				else
					
					'grab specified users details
					set rsUsers = server.createobject("adodb.recordset")
					sqlUsers = "SELECT User_ID, User_Name, User_Password, User_Address, User_Login FROM FS_Users WHERE User_ID = "& intUser &";"
					rsUsers.cursorlocation = 3
					rsUsers.open sqlUsers, adoConn
					if not (rsUsers.bof or rsUsers.eof) then
						intUsersCount = rsUsers.recordcount
						arrUsersData = rsUsers.getrows()
					else
						intUsersCount = 0
					end if
					rsUsers.close
					set rsUsers = nothing
					
					'increment query count
					intQuery = intQuery + 1
					
					'check a valid user has been specified
					if intUsersCount = 0 then
						response.redirect("/Admin/error.asp?Type=Users&Error=User&Redirect=/Admin/users_edit.asp")
					end if
					
					'check it's not the current users account
					if arrUsersData(0, 0) = session("FS_UserID") then
						response.redirect("/Admin/error.asp?Type=Users&Error=Self&Redirect=/Admin/users_edit.asp")
					end if
					
					'display users header
					response.write("<h1>Edit users</h1>")
					
					'display users details
					response.write("<p>")
						response.write("Use the form below to edit the specified users details in the Forest Site. Please pay attention to the description of each value and click submit once you have made the necassary changes.")
					response.write("</p>")
					
					'display user editing form
					response.write("<form action='users_submit.asp' method='post' onsubmit=""this.submit.disabled=true;"">")
						
						response.write("<table cellspacing='0' summary='Form to edit user accounts.'>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><b>ID#</b>:<br />The users unique ID number.</td>")
								response.write("<td class='details'>"& arrUsersData(0, 0) &"</td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><b>Address</b>:<br />The last IP address that the user connected from.</td>")
								response.write("<td class='details'>"& arrUsersData(3, 0) &"</td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><b>Login count</b>:<br />The number of time the user has logged in.</td>")
								response.write("<td class='details'>"& arrUsersData(4, 0) &"</td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='name'><b>Username</b></label>: *<br />The username for the user, this must not be a duplicate of an existing user.</td>")
								response.write("<td class='details'><input id='name' name='name' type='text' value="""& arrUsersData(1, 0) &""" size='22' maxlength='200' tabindex='1' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='password'><b>Password</b></label>: *<br />Please ensure that you use a secure password.</td>")
								response.write("<td class='details'><input id='password' name='password' type='password' value="""& arrUsersData(2, 0) &""" size='22' maxlength='200' tabindex='2' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='delete'><b>Delete user</b></label>:<br />Tick this box to delete this user from the Forest Site.</td>")
								response.write("<td class='details'><input id='delete' name='delete' type='checkbox' tabindex='3' value=""1"" /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'>&nbsp;</td>")
								response.write("<td class='details'><input id='user' name='user' type='hidden' value="""& arrUsersData(0, 0) &""" /><input id='submit' name='submit' type='submit' tabindex='4' value=""Submit"" class='button' /></td>")
							response.write("</tr>")
							
						response.write("</table>")
						
					response.write("</form>")
					
				end if
				%>
			</div>
			
			<div id="subcontent">
				<%
				'display navigation
				call display_navigation()
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>