<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'All Host Forest software is provided for free under a linkware license.
'You may modify any part of the software at your own risk, but the software
'(altered or otherwise) may not be distributed to entities beyond the
'license holder without the explicit written permission of the copyright holder.
'
'You may not remove, alter or otherwise disable all or any of the hyperlinks
'to the Host Forest website (http://www.hostforest.co.uk). All images, links or
'text must remain unchanged and intact and visible when the pages are viewed
'unless you first obtain explicit written permission from the copyright holders.
'
'Permission to remove the links, images and branding on a site by site basis
'basis can be obtained by purchasing the appropriate license from Host Forest
'by visiting http://www.hostforest.co.uk/Purchase/default.asp 
'
'You may not pass of in part or in whole any part of this software, including
'images and source code, as your own work. You may use parts of this program in
'your own private works, including images and source code, but you may NOT
'redistribute, repackage, sublicense or sell in part or in whole any part of
'this program regardless of any modifications that may have been made without
'the express written permission of the copyright holder.
'
'This software is provided WITHOUT warranty, either expressed or implied,
'including, but not limited to, the implied warranties of merchantability and
'fitness for a particular purpose. 
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->

<%
'dimension variables
dim sqlCreate
dim strTitle, strLocation, strName, strPassword, strAddress
dim intStep

if request.querystring("Step") <> "" then
	intStep = int(request.querystring("Step"))
else
	if request.querystring("Step") <> "" then
		intStep = int(request.querystring("Step"))
	else
		intStep = 1
	end if
end if
%>

<title>Forest Site Setup</title>

<link rel="stylesheet" type="text/css" href="/Themes/Rouge/inc-stylesheet.css" />
<link rel="shortcut icon" href="/Themes/Rouge/Common/favicon.ico" />

<style type="text/css">

#content
{
	width: 780px;
	
	/* over rides default width */
}

table .label
{
	width: 30%;
	
	/* defines left hand column when displaying editing form */
}

table .details
{
	width: 70%;
	
	/* defines right hand column in editing form */
}

form
{
	margin: 0;
	padding: 0;
}

form .text
{
	width: 275px;
}

form .select
{
	width: 280px;
}

form .textarea
{
	width: 275px;
}

form .button
{
	margin-right: 90px;
	float: right;
}

.clear
{
	margin-bottom: 10px;
}

</style>

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<h1>Forest Site Setup</h1>
			<h2>Follow the steps below to setup the Forest Site</h2>
		</div>
		
		<div id="navigation">
			&nbsp;
		</div>
						
		<div id="content">
			<%			
			select case intStep
			
				case 1
					
					response.write("<h1>Step 1</h1>")
					response.write("<p>")
						response.write("You are only a few steps away from completing the installation of the Forest Site software. Please make sure that you complete each step implicitly, failure to do so could prevent the Forest Site from running correctly and potentially corrupt your database.")
					response.write("</p>")
					
					response.write("<form action='setup.asp?Step=2' method='post' onsubmit=""this.submit.disabled=true;"">")
					
						response.write("<input id='submit' name='submit' type='submit' tabindex='7' value=""Step Two"" class='button' /></td>")
					
					response.write("</form>")
				
				case 2
					
					response.write("<h1>Step 2</h1>")
					
					response.write("<p>")
						response.write("Please complete the form below to set the default values for your Forest Site and create the default Administrative account. The administrative account has access to all of the Forest Site configuration, editing and user tools so please ensure that you specify a string alphanumeric password to protect your Forest Site security.")
					response.write("</p>")
					
					response.write("<p>")
						response.write("By clicking the button labelled <i>step three</i> you will initiate the creation of the tables required by the Forest Site software. All of the tables required by the Forest Site are prefixed <b>FS_</b> if you already have any tables in your database that follow this naming convention it is recommended that you rename them to prevent any errors.")
					response.write("</p>")
					
					response.write("<form action='setup.asp?Step=3' method='post' onsubmit=""this.submit.disabled=true;"">")
					
						response.write("<table cellspacing='0' summary='Create the default settings for the Forest Site.'>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='title'><b>Site title</b></label>:<br />This will be used in the Site header and in all communication sent from the site.</td>")
								response.write("<td class='details'><input id='title' name='title' type='text' value="""" size='22' maxlength='200' tabindex='1' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='location'><b>Site location</b></label>:<br />The URL where the site is located. Do NOT include any trailing / slashes.</td>")
								response.write("<td class='details'><input id='location' name='location' type='text' value=""http://"& request.servervariables("HTTP_HOST") &""" size='22' maxlength='200' tabindex='2' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='database'><b>Site database</b></label>:<br />The database that the site will run on. Please make sure that you have selected the correct database connection string within inc-dataconnection.asp.</td>")
								response.write("<td class='details'>")
									response.write("<select id='database' name='database' tabindex='3' class='select'>")
										response.write("<option value=""MYSQL"">MySQL</option>")
										response.write("<option value=""MSSQL"">MS SQL 2000</option>")
										response.write("<option value=""ACCESS"">MS Access</option>")
									response.write("</select>")
								response.write("</td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='name'><b>Administrator name</b></label>:<br />The username of the default Administrator account.</td>")
								response.write("<td class='details'><input id='name' name='name' type='text' value="""" size='22' maxlength='200' tabindex='4' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'><label for='password'><b>Administrator password</b></label>:<br />The password for the default Administrator account.</td>")
								response.write("<td class='details'><input id='password' name='password' type='text' value="""" size='22' maxlength='200' tabindex='5' class='text' /></td>")
							response.write("</tr>")
							
							response.write("<tr valign='top'>")
								response.write("<td class='label'>&nbsp;</td>")
								response.write("<td class='details'><input id='submit' name='submit' type='submit' tabindex='6' value=""Step Three"" class='button' /></td>")
							response.write("</tr>")
							
						response.write("</table>")
					
					response.write("</form>")
					
				case 3
					
					'load and check variables
					strTitle = clean_text(request.form("title"), 0)
					if left(request.form("location"), 7) <> "http://" then
						strLocation = "http://"& request.form("location")
					else
						strLocation = request.form("location")
					end if
					strName = clean_text(request.form("name"), 0)
					strPassword = clean_text(request.form("password"), 0)
					if request.servervariables("HTTP_X_FORWARDED_FOR") = "" then
						strAddress = request.servervariables("REMOTE_ADDR")
					else
						strAddress = request.servervariables("HTTP_X_FORWARDED_FOR")
					end If
					
					'check valid details have been entered
					if strTitle <> "" and strName <> "" and strPassword <> "" then
						
						select case request.form("database")
							
							case "MSSQL"
								
								'create configurations table
								sqlCreate = "CREATE TABLE FS_Configuration(Site_Name VARCHAR(255) NOT NULL, Site_Description TEXT NULL, Site_Location VARCHAR(255) NOT NULL, Site_Theme VARCHAR(255) NULL, Site_Meta_Keywords VARCHAR(255) NULL, Site_Meta_Description TEXT NULL);"
								adoConn.execute sqlCreate
								
								'create files table
								sqlCreate = "CREATE TABLE FS_Files (File_ID INTEGER NOT NULL IDENTITY (1, 1), File_Folder_ID INTEGER NULL, File_Name VARCHAR(255) NOT NULL, File_Location VARCHAR(255) NOT NULL);"
								adoConn.execute sqlCreate
								
								'add constraints
								sqlCreate = "ALTER TABLE FS_Files ADD CONSTRAINT PK_File_ID PRIMARY KEY (File_ID);"
								adoConn.execute sqlCreate
								
								'add index
								sqlCreate = "CREATE NONCLUSTERED INDEX IX_File_Folder_ID ON FS_Files (File_Folder_ID);"
								adoConn.execute sqlCreate
								
								'create folders table
								sqlCreate = "CREATE TABLE FS_Folders (Folder_ID INTEGER NOT NULL IDENTITY (1, 1), Folder_Title VARCHAR(255) NOT NULL, Folder_System INTEGER NOT NULL DEFAULT 0, Folder_Protected INTEGER NOT NULL DEFAULT 0);"
								adoConn.execute sqlCreate
								
								'add constraints
								sqlCreate = "ALTER TABLE FS_Folders ADD CONSTRAINT PK_Folder_ID PRIMARY KEY (Folder_ID);"
								adoConn.execute sqlCreate
								
								'create pages table
								sqlCreate = "CREATE TABLE FS_Pages (Page_ID INTEGER NOT NULL IDENTITY (1, 1), Page_Folder_ID INTEGER NULL, Page_Type INTEGER NOT NULL DEFAULT 0, Page_Title VARCHAR(255) NOT NULL, Page_Image VARCHAR(255) NULL, Page_Name VARCHAR(255) NULL, Page_URL VARCHAR(255) NOT NULL, Page_Order INTEGER NOT NULL DEFAULT 0);"
								adoConn.execute sqlCreate
								
								'add constraints
								sqlCreate = "ALTER TABLE FS_Pages ADD CONSTRAINT PK_Page_ID PRIMARY KEY (Page_ID);"
								adoConn.execute sqlCreate
								
								'add index
								sqlCreate = "CREATE NONCLUSTERED INDEX IX_Page_Folder_ID ON FS_Pages (Page_Folder_ID);"
								adoConn.execute sqlCreate
								
								'create users table
								sqlCreate = "CREATE TABLE FS_Users(User_ID INTEGER NOT NULL IDENTITY (1, 1), User_Name VARCHAR(100) NOT NULL, User_Password VARCHAR(60) NOT NULL, User_Address VARCHAR(15) NOT NULL, User_Login INTEGER NOT NULL DEFAULT 0);"
								adoConn.execute sqlCreate
								
								'add constraints
								sqlCreate = "ALTER TABLE FS_Users ADD CONSTRAINT PK_User_ID PRIMARY KEY (User_ID);"
								adoConn.execute sqlCreate
								
								'create files/folder relationship
								sqlCreate = "ALTER TABLE FS_Files ADD CONSTRAINT FK_FS_Folders_FS_Files FOREIGN KEY (File_Folder_ID) REFERENCES FS_Folders (Folder_ID);"
								adoConn.execute sqlCreate
								
								'create pages/folder relationship
								sqlCreate = "ALTER TABLE FS_Pages ADD CONSTRAINT FK_FS_Folders_FS_Pages FOREIGN KEY (Page_Folder_ID) REFERENCES FS_Folders (Folder_ID);"
								adoConn.execute sqlCreate
								
							case "MYSQL"
								
								'create configuration table
								sqlCreate = "CREATE TABLE FS_Configuration (Site_Name VARCHAR(255) NOT NULL, Site_Description TEXT NULL, Site_Location VARCHAR(255) NOT NULL, Site_Theme VARCHAR(255) NULL, Site_Meta_Keywords VARCHAR(255) NULL, Site_Meta_Description TEXT NULL);"
								adoConn.execute sqlCreate
								
								'create files table
								sqlCreate = "CREATE TABLE FS_Files (File_ID INTEGER NOT NULL AUTO_INCREMENT PRIMARY KEY, File_Folder_ID INTEGER NULL, File_Name VARCHAR(255) NOT NULL, File_Location VARCHAR(255) NOT NULL) TYPE=InnoDB"
								adoConn.execute sqlCreate
								
								'create indexes
								sqlCreate = "CREATE INDEX IX_File_Folder_ID ON FS_Files (File_Folder_ID);"
								adoConn.execute sqlCreate
								
								'create folders table
								sqlCreate = "CREATE TABLE FS_Folders (Folder_ID INTEGER NOT NULL AUTO_INCREMENT PRIMARY KEY, Folder_Title VARCHAR(255) NOT NULL, Folder_System INTEGER NOT NULL DEFAULT 0, Folder_Protected INTEGER NOT NULL DEFAULT 0) TYPE=InnoDB;"
								adoConn.execute sqlCreate
								
								'create pages table
								sqlCreate = "CREATE TABLE FS_Pages (Page_ID INTEGER NOT NULL AUTO_INCREMENT PRIMARY KEY, Page_Folder_ID INTEGER NULL, Page_Type INTEGER NOT NULL DEFAULT 0, Page_Title VARCHAR(255) NOT NULL, Page_Image VARCHAR(255) NULL, Page_Name VARCHAR(255) NULL, Page_URL VARCHAR(255) NOT NULL, Page_Order INTEGER NOT NULL DEFAULT 0) TYPE=InnoDB;"
								adoConn.execute sqlCreate
								
								'create indexes
								sqlCreate = "CREATE INDEX IX_Page_Folder_ID ON FS_Pages (Page_Folder_ID);"
								adoConn.execute sqlCreate
								
								'create users table
								sqlCreate = "CREATE TABLE FS_Users (User_ID INTEGER NOT NULL AUTO_INCREMENT PRIMARY KEY, User_Name VARCHAR(100) NOT NULL, User_Password VARCHAR(60) NOT NULL, User_Address VARCHAR(15) NOT NULL, User_Login INTEGER NOT NULL DEFAULT 0);"
								adoConn.execute sqlCreate
								
								'create files/folder relationship
								sqlCreate = "ALTER TABLE FS_Files ADD CONSTRAINT FK_FS_Folders_FS_Files FOREIGN KEY (File_Folder_ID) REFERENCES FS_Folders (Folder_ID);"
								adoConn.execute sqlCreate
								
								'create files/folder relationship
								sqlCreate = "ALTER TABLE FS_Pages ADD CONSTRAINT FK_FS_Folders_FS_Pages FOREIGN KEY (Page_Folder_ID) REFERENCES FS_Folders (Folder_ID);"
								adoConn.execute sqlCreate
								
						end select
						
						'insert configuration defaults
						sqlCreate = "INSERT INTO FS_Configuration (Site_Name, Site_Location, Site_Theme) VALUES ('"& strTitle &"', '"& strLocation &"', 'Rouge');"
						adoConn.execute sqlCreate
						
						'insert default folders
						sqlCreate = "INSERT INTO FS_Folders (Folder_Title, Folder_System, Folder_Protected) VALUES ('Admin', 1, 1);" 
						adoConn.execute sqlCreate
						
						sqlCreate = "INSERT INTO FS_Folders (Folder_Title, Folder_System, Folder_Protected) VALUES ('Includes', 1, 1);" 
						adoConn.execute sqlCreate
						
						sqlCreate = "INSERT INTO FS_Folders (Folder_Title, Folder_System, Folder_Protected) VALUES ('Themes', 1, 1);" 
						adoConn.execute sqlCreate
						
						'insert default pages
						sqlCreate = "INSERT INTO FS_Pages (Page_Folder_ID, Page_Type, Page_Title, Page_Image, Page_Name, Page_URL, Page_Order) VALUES (null, 0, 'Home', null, 'default.asp', '"& strLocation &"/default.asp', 0);"
						adoConn.execute sqlCreate
						
						'insert default user
						sqlCreate = "INSERT INTO FS_Users (User_Name, User_Password, User_Address, User_Login) VALUES ('"& strName &"', '"& strPassword &"', '"& strAddress &"', 0)"
						adoConn.execute sqlCreate
						
						'display confirmation
						response.write("<h1>Setup complete</h1>")
						
						response.write("<p>")
							response.write("All of the required database tables have now been created successfully, Please delete this page from your webspace so that it cannot be abused by ay other users. Please click <a href='default.asp' title='"& strTitle &"'>here</a> if you are not redirected within 10 seconds.")
						response.write("</p>")
						
						response.addheader "Refresh", "10; URL=default.asp"
						
					else
						
						response.write("<h1>Step 2</h1>")
					
						response.write("<p>")
							response.write("Please complete the form below to set the default values for your Forest Site and create the default Administrative account. The administrative account has access to all of the Forest Site configuration, editing and user tools so please ensure that you specify a string alphanumeric password to protect your Forest Site security.")
						response.write("</p>")
						
						response.write("<p>")
							response.write("By clicking the button labelled <i>step three</i> you will initiate the creation of the tables required by the Forest Site software. All of the tables required by the Forest Site are prefixed <b>FS_</b> if you already have any tables in your database that follow this naming convention it is recommended that you rename them to prevent any errors.")
						response.write("</p>")
						
						response.write("<form action='setup.asp?Step=3' method='post' onsubmit=""this.submit.disabled=true;"">")
						
							response.write("<table cellspacing='0' summary='Create the default settings for the Forest Site.'>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='title'><b>Site title</b></label>:<br />This will be used in the Site header and in all communication sent from the site.</td>")
									response.write("<td class='details'><input id='title' name='title' type='text' value="""" size='22' maxlength='200' tabindex='1' class='text' /></td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='location'><b>Site location</b></label>:<br />The URL where the site is located. Do NOT include any trailing / slashes.</td>")
									response.write("<td class='details'><input id='location' name='location' type='text' value=""http://"& request.servervariables("HTTP_HOST") &""" size='22' maxlength='200' tabindex='2' class='text' /></td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='database'><b>Site database</b></label>:<br />The database that the site will run on. Please make sure that you have selected the correct database connection string within inc-dataconnection.asp.</td>")
									response.write("<td class='details'>")
										response.write("<select id='database' name='database' tabindex='3' class='select'>")
											response.write("<option value=""MYSQL"">MySQL</option>")
											response.write("<option value=""MSSQL"">MS SQL 2000</option>")
											response.write("<option value=""ACCESS"">MS Access</option>")
										response.write("</select>")
									response.write("</td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='name'><b>Administrator name</b></label>:<br />The username of the default Administrator account.</td>")
									response.write("<td class='details'><input id='name' name='name' type='text' value="""" size='22' maxlength='200' tabindex='4' class='text' /></td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'><label for='password'><b>Administrator password</b></label>:<br />The password for the default Administrator account.</td>")
									response.write("<td class='details'><input id='password' name='password' type='text' value="""" size='22' maxlength='200' tabindex='5' class='text' /></td>")
								response.write("</tr>")
								
								response.write("<tr valign='top'>")
									response.write("<td class='label'>&nbsp;</td>")
									response.write("<td class='details'><input id='submit' name='submit' type='submit' tabindex='6' value=""Step Three"" class='button' /></td>")
								response.write("</tr>")
								
							response.write("</table>")
						
						response.write("</form>")
						
					end if						
					
			end select
			%>
		</div>
		
		<div id="footer">
			Powered by: <a href="http://www.hostforest.co.uk/Products/site.asp" rel="external" title="Forest Site">Forest Site</a> | Copyright &copy; 2005 <a href="http://www.hostforest.co.uk" rel="external" title="Host Forest">Host Forest</a>
		</div>
		
	</div>
	
</body>

</html>