<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'All Host Forest software is provided for free under a linkware license.
'You may modify any part of the software at your own risk, but the software
'(altered or otherwise) may not be distributed to entities beyond the
'license holder without the explicit written permission of the copyright holder.
'
'You may not remove, alter or otherwise disable all or any of the hyperlinks
'to the Host Forest website (http://www.hostforest.co.uk). All images, links or
'text must remain unchanged and intact and visible when the pages are viewed
'unless you first obtain explicit written permission from the copyright holders.
'
'Permission to remove the links, images and branding on a site by site basis
'basis can be obtained by purchasing the appropriate license from Host Forest
'by visiting http://www.hostforest.co.uk/Purchase/default.asp 
'
'You may not pass of in part or in whole any part of this software, including
'images and source code, as your own work. You may use parts of this program in
'your own private works, including images and source code, but you may NOT
'redistribute, repackage, sublicense or sell in part or in whole any part of
'this program regardless of any modifications that may have been made without
'the express written permission of the copyright holder.
'
'This software is provided WITHOUT warranty, either expressed or implied,
'including, but not limited to, the implied warranties of merchantability and
'fitness for a particular purpose. 
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->

<%
'dimension variables
dim sqlCreate
dim strTitle, strLocation, strName, strPassword, strAddress
dim intStep

if request.querystring("Step") <> "" then
	intStep = int(request.querystring("Step"))
else
	if request.querystring("Step") <> "" then
		intStep = int(request.querystring("Step"))
	else
		intStep = 1
	end if
end if
%>

<title>Forest Site Setup</title>

<link rel="stylesheet" type="text/css" href="/Themes/Rouge/inc-stylesheet.css" />
<link rel="shortcut icon" href="/Themes/Rouge/Common/favicon.ico" />

<style type="text/css">

#content
{
	width: 780px;
	
	/* over rides default width */
}

table .label
{
	width: 30%;
	
	/* defines left hand column when displaying editing form */
}

table .details
{
	width: 70%;
	
	/* defines right hand column in editing form */
}

form
{
	margin: 0;
	padding: 0;
}

form .text
{
	width: 275px;
}

form .select
{
	width: 280px;
}

form .textarea
{
	width: 275px;
}

form .button
{
	margin-right: 90px;
	float: right;
}

.clear
{
	margin-bottom: 10px;
}

</style>

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<h1>Forest Site Update</h1>
			<h2>Update v1.1.1 to v1.1.2</h2>
		</div>
		
		<div id="navigation">
			&nbsp;
		</div>
						
		<div id="content">
			<%			
			'check for form submission
			if request.form = "" then
				
				'display header
				response.write("<h1>v1.1.1 Updater</h1>")
				
				'display instructions
				response.write("<p>")
					response.write("This will update any MSSQL or MySQL Forest Site installation to v1.1.2, the Access version does not need any updates. Once the database updates are completed you will have to update the pages within your Forest Site installation to update the page templates by opening them within the application administration section and submitting them without changes.")
				response.write("</p>")
				
				response.write("<p>")
					response.write("Please select your database type from the form below and click update to continue.")
				response.write("</p>")
				
				response.write("<form action='update.asp' method='post' onsubmit=""this.submit.disabled=true;"">")
				
					response.write("<table cellspacing='0' summary='Your database type.'>")
						
						response.write("<tr valign='top'>")
							response.write("<td class='label'><label for='database'><b>Database</b>:<br />Please select your database.</td>")
							response.write("<td class='details'>")
								response.write("<select id='database' name='database' tabindex='2' class='select'>")
									response.write("<option value='MYSQL'>MySQL</option>")
									response.write("<option value='MSSQL'>MSSQL</option>")
								response.write("</select>")
							response.write("</td>")
						response.write("</tr>")
						
						response.write("<tr valign='top'>")
							response.write("<td class='label'></td>")
							response.write("<td class='details'><input id='submit' name='submit' type='submit' tabindex='3' value='Update' class='button' /></td>")
						response.write("</tr>")
						
					response.write("</table>")
				response.write("</form>")
				
			else
				
				'select the database tpe
				select case request.form("database")
					case "MSSQL"
						
						sqlUpdate = "CREATE NONCLUSTERED INDEX IX_File_Folder_ID ON FS_Files (File_Folder_ID);"
						adoConn.execute sqlUpdate
							
					case "MYSQL"
						
						sqlUpdate = "CREATE INDEX IX_File_Folder_ID ON FS_Files (File_Folder_ID);"
						adoConn.execute sqlUpdate
						
				end select
				
				'display header
				response.write("<h1>Forest Site Updated</h1>")
				
				'display instructions
				response.write("<p>")
					response.write("Forest Site has been successfully updated to version 1.1.2, for your security please delete the file update.asp from your web space.")
				response.write("</p>")
				
			end if
			%>
		</div>
		
		<div id="footer">
			Powered by: <a href="http://www.hostforest.co.uk/Products/site.asp" rel="external" title="Forest Site">Forest Site</a> | Copyright &copy; 2005 <a href="http://www.hostforest.co.uk" rel="external" title="Host Forest">Host Forest</a>
		</div>
		
	</div>
	
</body>

</html>